
define(['baja!','baja!electronicSignature:SecureActiveInactive',
        'lex!baja',
        'jquery',
        'Promise',
        'dialogs',
        'lex!electronicSignature',
        'bajaux/Widget',
        'bajaux/mixin/subscriberMixIn',
        'hbs!nmodule/electronicSignature/rc/fe/template/SecuredActiveInactiveTemplate',
        'nmodule/electronicSignature/rc/fe/baja/loader',
        'nmodule/webEditors/rc/fe/baja/BaseEditor',
         'nmodule/electronicSignature/rc/fe/baja/SecuredParentEditor',
        'css!nmodule/electronicSignature/rc/css/widgets'], function (
         baja,
         types,
         lexs,
         $,
         Promise,
         dialogs,
         electronicSignatureLex,
         Widget,
         subscriberMixIn,
         template,
         loader,
         BaseEditor,
         SecureParentEditor) {
  'use strict';

    var lex = electronicSignatureLex[0];
 /* function doFormat(pattern) {
    return baja.Format.format({ pattern: pattern });
  }*/

  /**
   * A field editor for working with booleans.
   *
   * @private
   * @class
   * @extends module:nmodule/webEditors/rc/fe/baja/BaseEditor
   * @alias module:nmodule/electronicSignature/rc/fe/baja/SecuredActiveInactiveEditor
   */
  var SecuredActiveInactiveEditor = function SecuredActiveInactiveEditor(params) {
    BaseEditor.call(this, $.extend({
      keyName: 'SecuredActiveInactiveEditor'
    }, params));
    subscriberMixIn(this);
  };

  SecuredActiveInactiveEditor.prototype = Object.create(SecureParentEditor.prototype);
  SecuredActiveInactiveEditor.componentFE = null;
  SecuredActiveInactiveEditor.prototype.doInitialize = function (dom) {
      var jsonObject={pointName:lex.get('fe.pointName.label'),
          reason:lex.get('fe.reason.label'),
          otherReason:lex.get('fe.otherReason.label'),
          authLevel1:lex.get('fe.authorization.level1.label'),
          authLevel2:lex.get('fe.authorization.level2.label'),
          userName:lex.get('fe.userName.label'),
          password:lex.get('fe.password.label'),
          comment:lex.get('fe.comment.label'),
          sign:lex.get('fe.sign.button'),
          sign2:lex.get('fe.sign2.button'),
          remote:lex.get('fe.remote.button'),
          chooseUser:lex.get('remote.chooseUser.label'),
          local:lex.get('remote.local.button'),
          sendRequest:lex.get('remote.sendRequest.button'),
          acknowledgement:lex.get('eSignature.ack.label'),
          label1:lex.get('eSignature.ack.label1'),
          label2:lex.get('eSignature.ack.label2'),
          label3:lex.get('eSignature.ack.label3'),
          label4:lex.get('eSignature.ack.label4'),
          label5:lex.get('eSignature.ack.label5'),
          label6:lex.get('eSignature.ack.label6'),
          label7:lex.get('eSignature.ack.label7')

      };
      dom.html(template({jsonObject:jsonObject}));

    this.doInitializeContent(dom);
  };

  SecuredActiveInactiveEditor.prototype.doLoad = function(secureActiveInactive,params)
  {
    var widget = this,
    dom = widget.jq();
    SecuredActiveInactiveEditor.componentFE = secureActiveInactive;
    var result = this.doLoadValue(dom,secureActiveInactive);
      if(result === "NOT_CONNECTED")
          return Promise.resolve("");
    return this.validateSecondaryUsers(secureActiveInactive);
  };

  SecuredActiveInactiveEditor.prototype.doSave = function (secureActiveInactive,params) {
     var secureActiveInactiveComp = this.value(),
     dom = this.jq(),
     secureActiveInactiveOldComp = SecuredActiveInactiveEditor.componentFE;
     secureActiveInactiveComp = SecureParentEditor.prototype.doSaveValue(secureActiveInactiveComp,dom);
     if(secureActiveInactiveComp.getOldValue()!==null){
       secureActiveInactiveComp.setOldValue(secureActiveInactiveOldComp.getNewValue());
     }
     return secureActiveInactiveComp;
  };

  return SecuredActiveInactiveEditor;
});