/**
 * @copyright 2017 Tridium, Inc. All Rights Reserved.
 * @author Balaji Gite
 */

define(['baja!','baja!electronicSignature:SecureAuto',
        'lex!baja',
        'jquery',
        'Promise',
        'dialogs',
        'lex!electronicSignature',
        'bajaux/Widget',
         'bajaux/mixin/subscriberMixIn',
         'hbs!nmodule/electronicSignature/rc/fe/template/SecuredAutoTemplate',
        'nmodule/electronicSignature/rc/fe/baja/loader',
        'nmodule/webEditors/rc/fe/baja/BaseEditor',
        'nmodule/electronicSignature/rc/fe/baja/SecuredParentEditor',
        'css!nmodule/electronicSignature/rc/css/widgets'], function (
         baja,
         types,
         lexs,
         $,
         Promise,
         dialogs,
         electronicSignatureLex,
         Widget,
         subscriberMixIn,
         template,
         loader,
         BaseEditor,
         SecuredParentEditor) {
  'use strict';

  var lex = electronicSignatureLex[0];
  /**
   * A field editor for working with booleans.
   *
   * @private
   * @class
   * @extends module:nmodule/webEditors/rc/fe/baja/BaseEditor
   * @alias module:nmodule/electronicSignature/rc/fe/baja/SecuredAutoEditor
   */
  var SecuredAutoEditor = function SecuredAutoEditor(params) {
    BaseEditor.call(this, $.extend({
      keyName: 'SecuredAutoEditor'
    }, params));
    subscriberMixIn(this);
  };
  
  SecuredAutoEditor.prototype = Object.create(SecuredParentEditor.prototype);
  SecuredAutoEditor.prototype.constructor = SecuredAutoEditor;
  SecuredAutoEditor.componentFE = null;

 SecuredAutoEditor.prototype.doInitialize = function (dom) {
     var jsonObject={pointName:lex.get('fe.pointName.label'),
         newValue:lex.get('fe.newValue.label'),
         reason:lex.get('fe.reason.label'),
         otherReason:lex.get('fe.otherReason.label'),
         authLevel1:lex.get('fe.authorization.level1.label'),
         authLevel2:lex.get('fe.authorization.level2.label'),
         userName:lex.get('fe.userName.label'),
         password:lex.get('fe.password.label'),
         comment:lex.get('fe.comment.label'),
         sign:lex.get('fe.sign.button'),
         sign2:lex.get('fe.sign2.button'),
         remote:lex.get('fe.remote.button'),
         chooseUser:lex.get('remote.chooseUser.label'),
         local:lex.get('remote.local.button'),
         sendRequest:lex.get('remote.sendRequest.button'),
         acknowledgement:lex.get('eSignature.ack.label'),
         label1:lex.get('eSignature.ack.label1'),
         label2:lex.get('eSignature.ack.label2'),
         label3:lex.get('eSignature.ack.label3'),
         label4:lex.get('eSignature.ack.label4'),
         label5:lex.get('eSignature.ack.label5'),
         label6:lex.get('eSignature.ack.label6'),
         label7:lex.get('eSignature.ack.label7')

     };
     dom.html(template({jsonObject:jsonObject}));
	this.doInitializeContent(dom);

 };
	
  SecuredAutoEditor.prototype.doLoad = function (secureAuto,params) {
    var widget = this,
    dom = widget.jq(),
    isValidUserDom = getPointNewValue(dom);
    SecuredAutoEditor.componentFE = secureAuto;
    var result = this.doLoadValue(dom,secureAuto);
    if(result === "NOT_CONNECTED")
        return Promise.resolve("");
    dom.find("#txtNewValue").val(isValidUserDom);
    return this.validateSecondaryUsers(secureAuto);
  };
  
  SecuredAutoEditor.prototype.doIsValueValid = function(dom)
  {
    var invalidList=[],
    invalidListObj = {};

    var newValueField = dom.find('#txtNewValue').val();
    if(newValueField==="")
    {
      invalidListObj = {};
      invalidListObj.id="txtNewValue";
      invalidListObj.errorMsg=lex.get('pointValue.format.error');
      invalidList.push(invalidListObj);
    }
    else
    {
      dom.find('#txtNewValue').removeClass("errorMsg");
    }
    return invalidList;
  };

  SecuredAutoEditor.prototype.doRead = function()
  {
    var that = this;
    var secureAuto = that.value();
    return secureAuto;
  };
  
  SecuredAutoEditor.prototype.doSave = function (secureAuto,params)
  {
    var dom = this.jq();
    secureAuto = this.doSaveValue(secureAuto,dom);
    return secureAuto;
  };

  function getPointNewValue(dom) {
    return dom.find(".newValue");
  }
  return SecuredAutoEditor;
});

