define(['baja!','baja!electronicSignature:SecureEnum,baja:EnumRange,baja:DynamicEnum,baja:StatusEnum',
       'lex!baja',
       'jquery',
       'Promise',
       'dialogs',
       'lex!electronicSignature',
       'bajaux/Widget',
       'underscore',
       'bajaux/mixin/subscriberMixIn',
       'hbs!nmodule/electronicSignature/rc/fe/template/SecuredEnumTemplate',
        'nmodule/electronicSignature/rc/fe/baja/loader',
        'nmodule/webEditors/rc/fe/baja/BaseEditor',
       'nmodule/electronicSignature/rc/fe/baja/SecuredParentEditor',
       'css!nmodule/electronicSignature/rc/css/widgets'], function (
        baja,
        types,
        lexs,
        $,
        Promise,
        dialogs,
        electronicSignatureLex,
        Widget,
        _,
        subscriberMixIn,
        template,
        loader,
        BaseEditor,
        SecureParentEditor) {
 'use strict';

  var lex = electronicSignatureLex[0];
  var _facets = null;
  var controlChoiceVal=null;
  var valuePresent=false;
 // var _SecondaryAuthenticatorRoles="";

  /**
  * A field editor for working with booleans.
  *
  * @private
  * @class
  * @extends module:nmodule/webEditors/rc/fe/baja/BaseEditor
  * @alias module:nmodule/electronicSignature/rc/fe/baja/SecuredEnumEditor
  */
  var SecuredEnumEditor = function SecuredEnumEditor(params) {
   BaseEditor.call(this, $.extend({
     keyName: 'SecuredEnumEditor'
   }, params));
   subscriberMixIn(this);
  };
   SecuredEnumEditor.isAuthenticatedUser = false;
   SecuredEnumEditor.componentFE = null;
   SecuredEnumEditor.prototype = Object.create(SecureParentEditor.prototype);
   SecuredEnumEditor.prototype.constructor = SecuredEnumEditor;

   SecuredEnumEditor.prototype.doInitialize = function (dom) {
       var jsonObject={pointName:lex.get('fe.pointName.label'),
           newValue:lex.get('fe.newValue.label'),
           reason:lex.get('fe.reason.label'),
           otherReason:lex.get('fe.otherReason.label'),
           authLevel1:lex.get('fe.authorization.level1.label'),
           authLevel2:lex.get('fe.authorization.level2.label'),
           userName:lex.get('fe.userName.label'),
           password:lex.get('fe.password.label'),
           comment:lex.get('fe.comment.label'),
           sign:lex.get('fe.sign.button'),
           sign2:lex.get('fe.sign2.button'),
           remote:lex.get('fe.remote.button'),
           chooseUser:lex.get('remote.chooseUser.label'),
           local:lex.get('remote.local.button'),
           sendRequest:lex.get('remote.sendRequest.button'),
           acknowledgement:lex.get('eSignature.ack.label'),
           label1:lex.get('eSignature.ack.label1'),
           label2:lex.get('eSignature.ack.label2'),
           label3:lex.get('eSignature.ack.label3'),
           label4:lex.get('eSignature.ack.label4'),
           label5:lex.get('eSignature.ack.label5'),
           label6:lex.get('eSignature.ack.label6'),
           label7:lex.get('eSignature.ack.label7')

       };
       dom.html(template({jsonObject:jsonObject}));
      this.doInitializeContent(dom);
   };

  function getNewValueDom(dom) {
   return dom.find(".newValue");
  }

  SecuredEnumEditor.prototype.doLoad = function(secureEnum,params){
    var widget = this,
    dom = widget.jq();
    _facets = secureEnum.getSecureSlotFacets();
    SecuredEnumEditor.componentFE = secureEnum;
    controlChoiceVal=secureEnum.getControlChoice().getValue();

    var result = this.doLoadValue(dom,secureEnum);
      if(result === "NOT_CONNECTED")
          return Promise.resolve("");

    if(controlChoiceVal!== null)
    {
      valuePresent = controlChoiceVal.getRange().getOrdinals().length>0;
      var enumOrdinals = controlChoiceVal.getRange().getOrdinals();
      var ordinal = controlChoiceVal.getOrdinal();
      var tempHtml ="";
      _.each(enumOrdinals,function(value,key){
        if(value === ordinal)
          {
          tempHtml+="<option ordinal="+value+" value="+value+" selected>"+controlChoiceVal.getRange().getTag(value)+"</option>";
          }
        else
          {
          tempHtml+="<option ordinal="+value+" value="+value+">"+controlChoiceVal.getRange().getTag(value)+"</option>";
          }

        dom.find("#txtNewValue").html(tempHtml);
      });
      if(valuePresent === false)
      {
        dom.find("#txtNewValue").html("<option ordinal="+ordinal+" value="+ordinal+" selected>"+ordinal+"</option>");
      }
      try {
          dom.find('#txtNewValue').editableSelect({filter: false});
      }
      catch (e) {
          setTimeout(function(){
              dom.find('#txtNewValue').editableSelect({filter: false});
          },1000);
      }
    }

    return this.validateSecondaryUsers(secureEnum);

  };

  SecuredEnumEditor.prototype.doIsValueValid = function(dom)
  {
    var invalidList=[],
    invalidListObj = {},
    ordinal=saveToOrdinal(dom);
    if(ordinal==="InvalidValue")
    {
      invalidListObj = {};
      invalidListObj.id="txtNewValue";
      invalidListObj.errorMsg=lex.get('enum.editor.value.validation');
      invalidList.push(invalidListObj);
    }
    else
    {
      dom.find('#txtNewValue').removeClass("errorMsg");
    }
    return invalidList;
  };

  SecuredEnumEditor.prototype.doRead = function()
  {
    var that = this;
    var dom = this.jq();
    var secureEnum = that.value();
    var secureEnumOld = SecuredEnumEditor.componentFE;
    secureEnum = savePointValues(this.jq(),secureEnumOld,secureEnum,{newValue: getNewValueDom(dom).val()});
    return secureEnum;
  };

  SecuredEnumEditor.prototype.doSave = function (secureEnum,params) {
    var dom = this.jq();
    secureEnum = this.doSaveValue(secureEnum,dom);
    return secureEnum;
  };


  function savePointValues(dom,OldComp,newComp,pointValue)
  {
    //Adding code for creating enumRange
    if(newComp.getNewValue()!== null)
    {
      newComp.setNewValue(pointValue.newValue);
    }
    var ordinal,dynamicEnum;
    if(valuePresent===true)
    {
      ordinal=saveToOrdinal(dom);
      dynamicEnum= baja.$("baja:DynamicEnum").make({ordinal:parseInt(ordinal), range:SecuredEnumEditor.componentFE.getControlChoice().getValue().getRange()});
    }
    else
    {
      ordinal=dom.find("input#txtNewValue").val();
      dynamicEnum = baja.$("baja:DynamicEnum").make(parseInt(ordinal));
    }
    return newComp.getControlChoice().setValue(dynamicEnum).then(function(newEnum){
      return newComp;
    });
  }

  function saveToOrdinal(dom)
  {
    var tag = dom.find("input#txtNewValue").val();
    if(valuePresent===true)
    {
        var enumOrdinals = controlChoiceVal.getRange().getOrdinals();
        var index = _.find(enumOrdinals,function(value){
            return tag.equals(controlChoiceVal.getRange().getTag(value, null));
        });
        if(!(index === undefined || index === null))
          return index;

        return "InvalidValue";
    }

    //Validation for hex numbers and normal numbers.
     var pattHex= /^(0[x])?[a-fA-F0-9]+$/;
     var resHex = pattHex.test(tag);
     var patt = /^[-+]?[0-9]+$/;
     var res = patt.test(tag);
    if(res===true || resHex===true)
    {
      if(isNaN(parseInt(tag))===false)
      {
        if(parseInt(tag)>2147483647 || parseInt(tag)<(-2147483648))
        {
         return "InvalidValue";
        }
        return tag;
      }
    }
    return "InvalidValue";
  }

  return SecuredEnumEditor;
});