define(['baja!',
        'baja!electronicSignature:SecuredNumericWritable,electronicSignature:SecuredBooleanWritable,electronicSignature:SecuredEnumWritable,electronicSignature:SecuredStringWritable,electronicSignature:SecuredNumericPoint,electronicSignature:SecuredBooleanPoint,electronicSignature:SecuredEnumPoint,electronicSignature:SecuredStringPoint',
        'jquery',
        'dialogs',
        'lex!electronicSignature',
        'Promise',
        'underscore',
        'lex!webEditors',
        'nmodule/webEditors/rc/fe/feDialogs',
        'nmodule/webEditors/rc/wb/commands/ComponentEditorCommand',
        'hbs!nmodule/electronicSignature/rc/fe/template/SecuredDeleteComponentTemplate',
        'nmodule/electronicSignature/rc/fe/baja/loader',
        'nmodule/electronicSignature/rc/fe/baja/Util',
        'css!nmodule/electronicSignature/rc/css/widgets'], function (
         baja,
         types,
         $,
         dialogs,
         electronicSignatureLex,
         Promise,
         _,
         lexs,
         feDialogs,
         ComponentEditorCommand,
         template,
         loader,
         Util) {
    'use strict';
    var webEditorsLex = lexs[0];
    var lex = electronicSignatureLex[0],
    DISPLAY_NAMES_FLAGS = baja.Flags.HIDDEN | baja.Flags.READONLY |
    baja.Flags.OPERATOR;

    var SecuredSetDisplayNameCmd = function SecuredSetDisplayNameCmd( component) {
      var that = this;
      ComponentEditorCommand.call(that, {
        module: 'webEditors',
        lex: 'commands.setDisplayName'
      }, component);
    };

    SecuredSetDisplayNameCmd.prototype = Object.create(ComponentEditorCommand.prototype);
    SecuredSetDisplayNameCmd.prototype.constructor = SecuredSetDisplayNameCmd;

    SecuredSetDisplayNameCmd.prototype.canPerformCommand = function (comp) {
      return comp.getPermissions().hasAdminWrite();
    };

    function loadComponentSlots(comp){
      return new Promise(function(fullfil,reject){
        comp.lease().then(function(){
          comp.loadSlots({
            ok:function(){
              fullfil(comp);
            },
            fail:function(){
              reject(comp);
            }
          });
        });
      });
    }

    SecuredSetDisplayNameCmd.prototype.performCommand = function (compObj, slots, params) {
      return loadComponentSlots(compObj).then(function(comp){
        var slot = slots[0];
         if (!slot) {
          return Promise.reject(new Error(lex.get('rename.slot.required')));
         }
        if(slot.getType().is(baja.$("electronicSignature:SecuredNumericWritable").getType()) || slot.getType().is(baja.$("electronicSignature:SecuredBooleanWritable").getType()) || slot.getType().is(baja.$("electronicSignature:SecuredEnumWritable").getType()) || slot.getType().is(baja.$("electronicSignature:SecuredStringWritable").getType()) || slot.getType().is(baja.$("electronicSignature:SecuredNumericPoint").getType()) || slot.getType().is(baja.$("electronicSignature:SecuredBooleanPoint").getType()) || slot.getType().is(baja.$("electronicSignature:SecuredEnumPoint").getType()) || slot.getType().is(baja.$("electronicSignature:SecuredStringPoint").getType())){
          var oldDisplayName = comp.getDisplayName(slot);
          slots[0].$val.getActionParameterDefault(slots[0].$val.getSlot("call")).then(function(actionPoint){
              var primarySignLabel = lex.get('fe.sign1.button');
              if(actionPoint.getSecureSlotFacets().$map.$map.isSecuredPrimary==true)
              {
                  primarySignLabel = lex.get('fe.sign.button');
              }
              var jsonObject={
              authLevel1:lex.get('fe.authorization.level1.label'),
              authLevel2:lex.get('fe.authorization.level2.label'),
              userName:lex.get('fe.userName.label'),
              password:lex.get('fe.password.label'),
              comment:lex.get('fe.comment.label'),
              sign:primarySignLabel,
              sign2:lex.get('fe.sign2.button'),
              acknowledgement:lex.get('eSignature.ack.label'),
              label1:lex.get('eSignature.ack.label1'),
              label2:lex.get('eSignature.ack.label2'),
              label3:lex.get('eSignature.ack.label3'),
              label4:lex.get('eSignature.ack.label4'),
              label5:lex.get('eSignature.ack.label5'),
              label6:lex.get('eSignature.ack.label6'),
              label7:lex.get('eSignature.ack.label7')
          };
          dialogs.showOkCancel({title:lex.get('authenticate.user.title'),content:template({jsonObject:jsonObject})}).ok(function(val){
            return feDialogs.showFor({
            title: webEditorsLex.get('commands.setDisplayName.description'),
            value: oldDisplayName
            }).then(function (newDisplayName) {
              if (newDisplayName !== null && newDisplayName !== oldDisplayName) {
                 return setDisplayName(comp, slot, newDisplayName).then(function(){
                    var dashboardHandle=actionPoint.getSecureSlotFacets().$map.$map.dashboardHandle;
                    return getDashBoardComponent(dashboardHandle).then(function(dashBoardComponent){
                      var primaryComments=val.jq().find("#primaryComment").val();
                      actionPoint.setActionName("setDisplayName");
                      if(actionPoint.getSecureSlotFacets().$map.$map.isSecuredPrimary==true)
                      {
                        actionPoint.setPrimaryComments(primaryComments);
                      }else
                      {
                         var secondaryComments=val.jq().find("#secondaryComments").val();
                         var managerName= val.jq().find("#secondaryUsername").val();
                         actionPoint.setPrimaryComments(primaryComments);
                         actionPoint.setSecondaryComments(secondaryComments);
                         actionPoint.setManager(managerName);
                      }
                      actionPoint.setNewValue(newDisplayName);
                      actionPoint.setOldValue(oldDisplayName);
                      var comp= baja.$("baja:Component", {
                         actionPoint: actionPoint,
                      });
                      return dashBoardComponent.invoke({slot:"updateHistory", value: comp});
                    });
                 });
              }
            });
          });
          Util.loadInitialEventsAndData(actionPoint,"displayName");
          }).catch(function (err) {
            return dialogs.showOk({
            title: "Error",
            content:lex.get('editor.primary.user.validation')
            });
          });
        }
        else{
            var oldDisplayName = comp.getDisplayName(slot);

            return feDialogs.showFor({
              title: webEditorsLex.get('commands.setDisplayName.description'),
              value: oldDisplayName
            })
              .then(function (newDisplayName) {
                if (newDisplayName !== null &&
                  newDisplayName !== oldDisplayName) {
                  return setDisplayName(comp, slot, newDisplayName);
                }
              });
        }
      });
    };
    function getDashBoardComponent(handle) {
      var ord="station:|h:"+handle;
      return baja.Ord.make(ord).get({lease: true});
    }
    function setDisplayName(comp, slot, newDisplayName) {
      var arg = {},
          displayNames = comp.get('displayNames'),
          method;

      if (displayNames) {
        method = 'set';
        addAll(arg, displayNames);
      } else {
        method = 'add';
      }

      if (newDisplayName) {
        arg[slot] = newDisplayName;
      } else {
        delete arg[slot];
      }

      return comp[method]({
        slot: 'displayNames',
        value: baja.NameMap.make(arg),
        flags: DISPLAY_NAMES_FLAGS //ignored in set()
      }).then(function(comp){
        console.log(comp);
      });
    }

    function addAll(obj, nameMap) {
      _.each(nameMap.list(), function (key) {
        obj[key] = nameMap.get(key);
      });
    }

    return SecuredSetDisplayNameCmd;
    });