define(['baja!','baja!electronicSignature:SecureStringOverride,control:StringOverride',
        'lex!baja',
        'jquery',
        'Promise',
        'dialogs',
        'lex!electronicSignature',
        'bajaux/Widget',
        'bajaux/mixin/subscriberMixIn',
        'nmodule/webEditors/rc/fe/baja/OverrideRelTimeEditor',
        'hbs!nmodule/electronicSignature/rc/fe/template/SecuredStringOverrideTemplate',
        'nmodule/electronicSignature/rc/fe/baja/loader',
        'nmodule/webEditors/rc/fe/baja/BaseEditor',
        'nmodule/electronicSignature/rc/fe/baja/SecuredParentEditor',
        'bajaux/events',
        "nmodule/webEditors/rc/fe/fe",
        'nmodule/webEditors/rc/fe/baja/OverrideEditor',
        'css!nmodule/electronicSignature/rc/css/widgets'], function (
         baja,
         types,
         lexs,
         $,
         Promise,
         dialogs,
         electronicSignatureLex,
         Widget,
         subscriberMixIn,
         OverrideRelTimeEditor,
         template,
         loader,
         BaseEditor,
         SecuredParentEditor,
         events,
         fe,
         OverrideEditor) {
  'use strict';
  var lex = electronicSignatureLex[0];

  /**
   * A field editor for working with booleans.
   *
   * @private
   * @class
   * @extends module:nmodule/webEditors/rc/fe/baja/BaseEditor
   * @alias module:nmodule/electronicSignature/rc/fe/baja/SecuredStringOverrideEditor
   */
  var SecuredStringOverrideEditor = function SecuredStringOverrideEditor(params) {
    BaseEditor.call(this, $.extend({
      keyName: 'SecuredStringOverrideEditor'
    }, params));
    subscriberMixIn(this);
  };

  SecuredStringOverrideEditor.componentFE = null;
  SecuredStringOverrideEditor.prototype = Object.create(SecuredParentEditor.prototype);
  SecuredStringOverrideEditor.prototype.constructor = SecuredStringOverrideEditor;

  SecuredStringOverrideEditor.prototype.doInitialize = function (dom) {
      var jsonObject={pointName:lex.get('fe.pointName.label'),
          overrideValue:lex.get('editor.override.val'),
          overrideDuration:lex.get('editor.override.duration'),
          reason:lex.get('fe.reason.label'),
          otherReason:lex.get('fe.otherReason.label'),
          authLevel1:lex.get('fe.authorization.level1.label'),
          authLevel2:lex.get('fe.authorization.level2.label'),
          userName:lex.get('fe.userName.label'),
          password:lex.get('fe.password.label'),
          comment:lex.get('fe.comment.label'),
          sign:lex.get('fe.sign.button'),
          sign2:lex.get('fe.sign2.button'),
          remote:lex.get('fe.remote.button'),
          chooseUser:lex.get('remote.chooseUser.label'),
          local:lex.get('remote.local.button'),
          sendRequest:lex.get('remote.sendRequest.button'),
          acknowledgement:lex.get('eSignature.ack.label'),
          label1:lex.get('eSignature.ack.label1'),
          label2:lex.get('eSignature.ack.label2'),
          label3:lex.get('eSignature.ack.label3'),
          label4:lex.get('eSignature.ack.label4'),
          label5:lex.get('eSignature.ack.label5'),
          label6:lex.get('eSignature.ack.label6'),
          label7:lex.get('eSignature.ack.label7')

      };
      dom.html(template({jsonObject:jsonObject}));
    this.doInitializeContent(dom);
  };

  SecuredStringOverrideEditor.prototype.loadOverrideFE = function(dom, override)
  {
    var overrideDom = $("#overrideValue",dom);
    return fe.buildFor({
      dom: overrideDom,
      value: override,
      type: OverrideEditor,
      formFactor: "mini"
    }).then(function(overrideEditor){
      if($(overrideDom).find(".col-display").length>0)
      {
        $(overrideDom).find(".col-display").hide();
        $(overrideDom).find(".key-value").hide();
        $('.easNewValue', dom).find("#nvLabel").html(lex.get("duration"));
      }
      overrideEditor.jq().on(events.MODIFY_EVENT, function(){
          return overrideEditor.read().then(function(override){
            setTimeout(function(){  // jshint ignore:line
               $('.js-dialog-button-ok').attr('disabled', true);
            },100);
          });
       });
       return overrideEditor;
    });
  };

  SecuredStringOverrideEditor.prototype.doLoad = function (secureStringOverride,params)
  {
      var widget = this, dom = widget.jq();
      SecuredStringOverrideEditor.componentFE = secureStringOverride;
      var result = this.doLoadValue(dom,secureStringOverride);
      if(result === "NOT_CONNECTED")
          return Promise.resolve("");
      
      if(secureStringOverride.getSecureSlotFacets().$map.get("isMultiline") === "true"){
      	var input    = dom.find("#txtNewValue")[0],
        textarea = document.createElement('textarea');  // jshint ignore:line
        textarea.id    = input.id;
        textarea.cols  = 25.5;
        textarea.rows  = 2;
        textarea.class = "newValue fixControlWidth";
        textarea.value = secureStringOverride.getValue();
        input.parentNode.replaceChild(textarea, input);
      }else{
      	dom.find("#txtNewValue").val(secureStringOverride.getValue());
      }
      

      var promise = widget.loadOverrideFE(dom,secureStringOverride.getOverride());
      var overrideEditor;
      return Promise.resolve(promise).then(function(fe){
        overrideEditor = fe;
        return overrideEditor.setReadonly(false);
      }).then(function(){
        overrideEditor.$builder.getEditorFor('duration').setModified(true);
        overrideEditor.setModified(true);
        return widget.validateSecondaryUsers(secureStringOverride);
      });
  };

  SecuredStringOverrideEditor.prototype.doIsValueValid = function(dom)
  {
    var invalidList=[], invalidListObj = {};
    var overrideWidget = $("#overrideValue", dom).data('widget');
    var promise = new Promise(function(resolve, reject){
     overrideWidget.save().then(function(){
       overrideWidget.doRead().then(function(newValueField){
         try
         {
           baja.$("baja:RelTime").make(overrideWidget.$builder.$dataSource.$map.get("duration").$val.$ms);
         }
         catch(err)
         {
           // No logging as overrideWidget.$builder.$dataSource.$map becomes null when duration is permanent.
         }
         resolve(invalidList);
       });
     },function(err){
        if(err)
        {
            invalidListObj = {};
            invalidListObj.id="staticParent";
            invalidListObj.errorMsg=err;
            invalidList.push(invalidListObj);
        }
        else
        {
          dom.find('#staticParent').removeClass("errorMsg");
        }
        resolve(invalidList);
     });
    });

    return promise;
  };

  SecuredStringOverrideEditor.prototype.doRead = function()
  {
    var that = this;
    var dom = this.jq();

    var FE = $("#overrideValue",dom).data('widget');
    FE.setModified(true);
    FE.$builder.getEditorFor('duration').setModified(true);

    return FE.read().then(function(overrideValue){

      var secureStringOverride = that.value();
      secureStringOverride.setValue(dom.find("#txtNewValue")[0].value);
      if(!_.isEmpty(overrideValue.$map)) // jshint ignore:line
      {
        var duration = baja.$("baja:RelTime").make(overrideValue.$map.duration.$ms);
        var overrideVal = baja.$("control:StringOverride",{ duration : duration, value: dom.find("#txtNewValue")[0].value });
        return secureStringOverride.setOverride(overrideVal).then(function()
        {
          return secureStringOverride;
        });
      }
      else
      {
        return secureStringOverride.getOverride().setValue(dom.find("#txtNewValue")[0].value).then(function(){
          return secureStringOverride;
        });
      }
    });
  };

  SecuredStringOverrideEditor.prototype.doSave = function (secureStringOverride,params)
  {
    var dom = this.jq();
    secureStringOverride = this.doSaveValue(secureStringOverride,dom);
    return secureStringOverride;
  };

  return SecuredStringOverrideEditor;
});

