/**
 * This JS is called from Workbench->com.secured.ui.mgr.alarm.hx.BProtectedHxAlarmConsoleView
 * BProtectedHxAlarmConsoleView is agent on ProtectedWbAlarmConsole which in-turn is agent
 * on BProtectedAlarmConsole.
 */
define([
  'baja!',
  'jquery',
  'underscore',
  'Promise',
  'dialogs',
  'bajaux/events',
  'nmodule/webEditors/rc/fe/fe',
  'hbs!nmodule/electronicSignature/rc/fe/template/ProtectedAlarmConsole',
  'lex!electronicSignature',
  'nmodule/electronicSignature/rc/fe/baja/Util',
  'nmodule/electronicSignature/rc/jsFiles/bootstrap.min',
  'css!nmodule/electronicSignature/rc/css/widgets'
], function (baja, $, _, Promise, dialogs, events, fe,
             authenticationTemplate,lexs,Util,bootstrap) {

  'use strict';

  var secureDashboardConfiguration=null,
      isAuthenticatedUser = false,
      electronicSignatureLex = lexs[0];
    var legalTextTemplate ="";
    var customerName ="";

  var ProtectedAlarmMaintance = function ProtectedAlarmMaintance() {
  };

  //extend and set up prototype chain
  ProtectedAlarmMaintance.prototype = Object.create(Object.prototype);
  ProtectedAlarmMaintance.prototype.constructor = ProtectedAlarmMaintance;
  ProtectedAlarmMaintance.prototype.authenticateUser = function(secureDashboard,button) {
        secureDashboardConfiguration = secureDashboard;

        return loadComponentSlots(secureDashboardConfiguration).then(function(secureDashboardConfigurationLeased){
          var primaryUsername = baja.getUserName();
              var jsonObject={
                  authLevel1:electronicSignatureLex.get('fe.authorization.level1.label'),
                  userName:electronicSignatureLex.get('fe.userName.label'),
                  password:electronicSignatureLex.get('fe.password.label'),
                  notes:electronicSignatureLex.get('fe.sign.button.Alarm.Notes'),
                  sign:electronicSignatureLex.get('fe.sign.button.Alarm.Ack'),
                  acknowledgement:electronicSignatureLex.get('eSignature.ack.label'),
                  label1:electronicSignatureLex.get('eSignature.ack.label1'),
                  label2:electronicSignatureLex.get('eSignature.ack.label2'),
                  label3:electronicSignatureLex.get('eSignature.ack.label3'),
                  label4:electronicSignatureLex.get('eSignature.ack.label4'),
                  label5:electronicSignatureLex.get('eSignature.ack.label5'),
                  label6:electronicSignatureLex.get('eSignature.ack.label6'),
                  label7:electronicSignatureLex.get('eSignature.ack.label7')
              };
              var authenticatePromise = dialogs.showOkCancel({title:electronicSignatureLex.get("authenticate.user.title"),content:authenticationTemplate({jsonObject:jsonObject})}).ok(function(val){
                // Alarm related call
                  $($(document).find("#hiddenNotes")[0]).val($('#primaryComment').val());
                  $($(document).find( "#hiddenButton" )[0]).attr("onclick",$(button).data("onclick"));
                  $($(document).find( "#hiddenButton" )[0]).click();
                  Util.changeLegalText(primaryUsername,secureDashboardConfigurationLeased);

              });

              $(document).find("#username").val(primaryUsername);
              $(document).find('.js-dialog-button-ok').attr('disabled', true);

              $(document).find("#secondaryUsername").change(function(){
                 $(document).find('.js-dialog-button-ok').attr('disabled', true);
              });

            customerName = secureDashboardConfigurationLeased.getCustomer().getCustomerName();
            Util.changeLegalText(primaryUsername,secureDashboardConfigurationLeased);

              $(document).find("#btnPrimarySign").click(function (){
                  var credentials = {};
                  credentials.username = $('#username').val();
                  credentials.password = $('#password').val();
                  checkPrimarySign(credentials, secureDashboardConfigurationLeased);
              });

              $(document).find(".primaryTab").click(function (e){
                e.preventDefault();
              });

        });

  };

  function authenticateSecondaryUser(component, userName)
  {
      return component.invoke({
          slot: "call",
          value: baja.$("baja:String").make("getSecondaryUserDetails," + userName.toString())
      });
  }

  function checkSecondarySign(credentials, pointComponent)
  {
      $('.js-dialog-button-ok').attr('disabled', true);
      isAuthenticatedUser = false;
      if ((credentials.username).toLowerCase() === (credentials.primaryUserName).toLowerCase())
      {
          return dialogs.showOk({
              title: electronicSignatureLex.get("authentication.error.title"),
              content: electronicSignatureLex.get("level2.authentication.message")
          });
      }
      var validation = doIsDataValid("secondary");
      if (validation !== null && validation.length > 0)
      {
          showValidationSummary(validation);
      }
      else
      {
          var pointOrd = getFormatedPointOrd(pointComponent),
              pointComp,
              isValidManager = false;
          if (pointOrd !== "")
          {
              getComponentByOrd(pointOrd).then(function (comp)
              {
                  pointComp = comp;
                  dom.find(".btnSecondarySign").html(lex.get('fe.signing.button'));
                  dom.find(".btnSecondarySign").prop("disabled", true);
                  return authenticateUser(comp, baja.$("baja:String").make(credentials.username + ";" + btoa(credentials.password)));
              }).then(function (authenticatedComp){
                  dom.find(".btnSecondarySign").html(lex.get('fe.sign.button'));
                  dom.find(".btnSecondarySign").prop("disabled", false);
                  isValidManager = authenticatedComp;
                  if (authenticatedComp)
                  {
                      $('.js-dialog-button-ok').attr('disabled', false);
                      //isAuthenticatedUser = true;
                      return dialogs.showOk({
                          title: electronicSignatureLex.get("auth.success.title"),
                          content: electronicSignatureLex.get("auth.success.msg")
                      });
                      //return authenticateSecondaryUser(pointComp, credentials.username);
                  }
                  else
                  {
                      return dialogs.showOk({
                          title: electronicSignatureLex.get("authentication.error.title"),
                          content: electronicSignatureLex.get("authentication.error.message")
                      });
                  }
              })
              .catch(function (error)
              {
                  dom.find(".btnSecondarySign").html(lex.get('fe.sign.button'));
                  dom.find(".btnSecondarySign").prop("disabled", false);
                  console.log(error); // jshint ignore:line
              });
          }
          else
          {
              return dialogs.showOk({
                  title: electronicSignatureLex.get("authentication.error.title"),
                  content: electronicSignatureLex.get("authentication.error.message")
              });
          }
      }
  }

  function showValidationSummary(validationSummary)
  {
      var errorMessage = "";
      var index = 0;
      for (var i = 0; i < validationSummary.length; i++)
      {
          $("#" + validationSummary[i].id).addClass("errorMsg");
          if (validationSummary[i].errorMsg !== "")
          {
              index = index + 1;
              errorMessage += "<b>" + index + "</b>" + ". " + validationSummary[i].errorMsg + "</br>";
          }
      }
      return dialogs.showOk({
          title: electronicSignatureLex.get("error.massages.title"),
          content: errorMessage
      });
  }

  function getFormatedPointOrd(component)
  {
      var pointOrd = "";

      pointOrd = "station:|h:" + component.getHandle().toString();

      return pointOrd;
  }

  function getComponentByOrd(ord)
  {
      return baja.Ord.make(ord).get({lease: true});
  }

  function authenticateUser(component, credentials)
  {
      return new Promise(function (resolve, reject) {
          component.invoke({
              slot: "call",
              value: baja.$("baja:String").make("authenticateUser," + credentials.toString())
          }).then(function (authenticatedComp)
          {
              if(authenticatedComp.getSlot("authenticationJobOrd")===null)
              {
                  resolve(authenticatedComp.get("isValidUser"));
              }
              else
              {
                  let getJobStatus = ()=>{
                      component.invoke({
                          slot: "call",
                          value: baja.$("baja:String").make("LDAPAuthentication," + authenticatedComp.get("authenticationJobOrd").toString())
                      }).then(function(returnComponent){
                          if(returnComponent.get("jobStatus")===baja.$("baja:JobState").get("running"))
                          {
                              //schedule the timeout.
                              setTimeout(function (){
                                  getJobStatus();
                              },1000);
                          }
                          else
                          {
                              resolve(returnComponent.get("jobStatus")===baja.$("baja:JobState").get("success"));
                          }
                      });
                  };
                  setTimeout(function (){
                      getJobStatus();
                  },1000);
              }
          }).catch(function(err){
              console.log("Error occurred while authenticating the user.", err);
              reject();
          });
      });
  }

  function checkPrimarySign(credentials, pointComponent)
  {
      isAuthenticatedUser = false;
      var validation = doIsDataValid("primary");
      if (validation !== null && validation.length > 0)
      {
        showValidationSummary(validation);
      }
      else
      {
        var pointOrd = getFormatedPointOrd(pointComponent);
        if (pointOrd !== "")
        {
            getComponentByOrd(pointOrd).then(function (comp)
            {
                dom.find("#btnPrimarySign").html(lex.get('fe.signing.button'));
                dom.find("#btnPrimarySign").prop("disabled", true);
                return authenticateUser(comp, baja.$("baja:String").make(credentials.username + ";" + btoa(credentials.password)));
            }).then(function (authenticatedComp)
            {
                dom.find("#btnPrimarySign").html(lex.get('fe.sign.button'));
                dom.find("#btnPrimarySign").prop("disabled", false);
                if (authenticatedComp)
                {
                    isAuthenticatedUser = true;
                    $('.js-dialog-button-ok').attr('disabled', false);
                    //isAuthenticatedUser = true;
                    return dialogs.showOk({
                        title: "Authentication Successful",
                        content: "Please click on OK button to continue"
                    });
                    //$('.js-dialog-button-ok').attr('disabled', true);
                    //$('.nav-tabs a[href="#easSecondarySignature"]').tab('show');
                }
                else
                {
                    return dialogs.showOk({
                        title: electronicSignatureLex.get("error.massages.title"),
                        content: electronicSignatureLex.get("authentication.error.message")
                    });
                }
            }).catch(function (error)
            {
                dom.find("#btnPrimarySign").html(lex.get('fe.sign.button'));
                dom.find("#btnPrimarySign").prop("disabled", false);
                console.log(error); // jshint ignore:line
            });
            ;
        }
      }
  }

  function doIsDataValid(authenticationType)
  {
      var invalidList = [];
      var invalidListObj = {};
      if (authenticationType === "primary")
      {
          if ($('#username').val() === null || $('#username').val() === "")
          {
              invalidListObj = {};
              invalidListObj.id = "username";
              invalidListObj.errorMsg = electronicSignatureLex.get("parent.editor.userName.mandatory");
              invalidList.push(invalidListObj);
          }
          else
          {
              $('#username').removeClass("errorMsg");
          }
          if ($('#password').val() === null || $('#password').val() === "")
          {
              invalidListObj = {};
              invalidListObj.id = "password";
              invalidListObj.errorMsg = electronicSignatureLex.get("parent.editor.password.mandatory");
              invalidList.push(invalidListObj);
          }
          else
          {
              $('#password').removeClass("errorMsg");
          }
          if ($('#primaryComment').val() === null || $('#primaryComment').val() === "")
          {
              invalidListObj = {};
              invalidListObj.id = "primaryComment";
              invalidListObj.errorMsg = "Notes are mandatory";
              invalidList.push(invalidListObj);
          }
          else
          {
              $('#primaryComment').removeClass("errorMsg");
          }
          return invalidList;
      }
      if (authenticationType === "secondary")
      {

          if ($('#secondaryUsername').val() === null || $('#secondaryUsername').val() === "")
          {
              invalidListObj = {};
              invalidListObj.id = "secondaryUsername";
              invalidListObj.errorMsg =  electronicSignatureLex.get("parent.editor.userName.mandatory");
              invalidList.push(invalidListObj);
          }
          else
          {
              $('#secondaryUsername').removeClass("errorMsg");
          }
          if ($('#secondaryPassword').val() === null || $('#secondaryPassword').val() === "")
          {
              invalidListObj = {};
              invalidListObj.id = "secondaryPassword";
              invalidListObj.errorMsg = electronicSignatureLex.get("parent.editor.password.mandatory");
              invalidList.push(invalidListObj);
          }
          else
          {
              $('#secondaryPassword').removeClass("errorMsg");
          }
          return invalidList;
      }
  }


  function loadComponentSlots(comp){
    return new Promise(function(fullfil,reject){
      comp.lease().then(function(){
        comp.loadSlots({
          ok:function(){
            fullfil(comp);
          },
          fail:function(){
            reject(comp);
          }
        });
      });
    });
  }

  function fetchSecondaryUser(component, currentUser, slotName)
  {
      return component.invoke({
          slot: "call",
          value: baja.$("baja:String").make("getSecondaryUsers," + currentUser + "," + slotName)
      });
  }

  return ProtectedAlarmMaintance;
});
