/**
 * @copyright 2017 Tridium, Inc. All Rights Reserved.
 * @author Smita Rajge
 */

/**
 * @private
 * @module nmodule/electronicSignature/rc/wb/mgr/editor/ReasonEditor
 */
define(['baja!',
        'lex!electronicSignature',
        'bajaux/events',
        'jquery',
         'dialogs',
        'Promise',
        'underscore',
        'nmodule/js/rc/asyncUtils/asyncUtils',
        'nmodule/webEditors/rc/fe/fe',
        'nmodule/webEditors/rc/fe/baja/BaseEditor',
        'nmodule/webEditors/rc/fe/baja/util/ComplexDiff',
        'nmodule/webEditors/rc/util/ListSelection',
        'nmodule/webEditors/rc/util/Switchboard',
        'nmodule/webEditors/rc/wb/mgr/MgrSheet',
        'nmodule/webEditors/rc/wb/mgr/model/MgrColumn',
        'nmodule/webEditors/rc/wb/mgr/model/MgrModelCompositeBuilder',
        'nmodule/webEditors/rc/wb/mgr/BatchComponentEditor',
        'nmodule/webEditors/rc/wb/table/Table'], function (
         baja,
         electronicSignatureLex,
         events,
         $,
          dialogs,
         Promise,
         _,
         asyncUtils,
         fe,
         BaseEditor,
         ComplexDiff,
         ListSelection,
         Switchboard,
         MgrSheet,
         MgrColumn,
         MgrModelCompositeBuilder,
         BatchComponentEditor,
         Table) {

  'use strict';
  var lex = electronicSignatureLex[0];
 var flag=1;
 var editflag=1;

  /**
   * Editor intended for use with a `MgrModel`, allowing multiple components
   * to be edited simultaneously.
   *
   * @private
   * @class
   * @alias module:nmodule/electronicSignature/rc/wb/mgr/editor/CustomerEditor
   * @extends module:nmodule/webEditors/rc/wb/mgr/BatchComponentEditor
   */
  var ReasonEditor = function ReasonEditor() {
    var that = this,
    selection = that.$selection = new ListSelection();
    BaseEditor.apply(that, arguments);
    that.reasonHandle=arguments[0].reasonSetHandle;
    selection.select(0);

    selection.on('changed', function () {
      that.$onSelectionChanged();
    });

    new Switchboard(that)
      .allow('$onSelectionChanged')
      .oneAtATime().onRepeat().preempt();

    /**
     * A ReasonEditor will fail to validate under the following conditions:
     *
     * - phone number should be valid entry or blank.
     * @method module:nmodule/webEditors/rc/fe/baja/NumericEditor#validate
     */

    flag=1;
    editflag=1;
    var command=arguments[0].com;
    if(command==="Add")
    {
    that.validators().add(function (val) {
    return that.validateAddReason(val,that);
    });
    }else
    {
      that.validators().add(function (val) {
        return that.validateEditReason(val,that);
        });
    }

  };
  ReasonEditor.reasonHandle="";
  ReasonEditor.prototype = Object.create(BatchComponentEditor.prototype);
  ReasonEditor.prototype.constructor = ReasonEditor;


  function getReasonSet(handle) {
      var ord='station:|h:'+handle;
        return baja.Ord.make(ord).get({lease: true});
   }
  ReasonEditor.prototype.validateAddReason =function(val,that)
  {
    var errorMessage="";
    var index = 0;
 //   jQuery(jQuery("tr.key-reasonSetName").find("input[type='text']")[0]).attr('readonly', true);
    if(flag!==1)
    {
    return new Promise( function(fulfill,reject){
       return getReasonSet(that.reasonHandle).then(function(securedDashboardComp){
         if(val.$rows[0].$data["proposed.__name"]!==undefined && val.$rows[0].$data["proposed.__name"] === "")
         {
         index = index +1;
         errorMessage+=  lex.get('specify.name.message')+"<br>";
         }
         if(val.$rows[0].$data["proposed.__name"]!==undefined && securedDashboardComp.getSlot(baja.SlotPath.escape(val.$rows[0].$data["proposed.__name"]))!==null)
         {
           index = index +1;
           errorMessage+= lex.get('reasonSet.name.validation')+"<br>";
         }
         if(val.$rows[0].$data["proposed.reasonForChange"]=== undefined || !(val.$rows[0].$data["proposed.reasonForChange"].length>0 && val.$rows[0].$data["proposed.reasonForChange"].length<=50))
         {
           index = index +1;
           errorMessage+= lex.get('mgr.validation.reasonForChange.length');
         }
         if(errorMessage.length>0)
         {
          dialogs.showOk({
                          title: lex.get('error.title'),
                          content:errorMessage
                        });
                //throw "error";
                return false;
                }else
                {
         fulfill(errorMessage);
         }
       },
       function(err){
       reject(err);
       });
    });
    //flag=flag+1;
    }else
    {
    return new Promise( function(fulfill,reject){
    flag=flag+1;
    fulfill(errorMessage);
    });
    }

  };
  function hasDuplicates(myArray) {
       return !(myArray.length === _.uniq(myArray).length);  // jshint ignore:line
  }

 ReasonEditor.prototype.validateEditReason =function(val,that)
  {
    var errorMessage="";
    var index = 0;
    var invalidData=false;
    if(editflag!==1)
    {
    return new Promise( function(fulfill,reject){
       return getReasonSet(that.reasonHandle).then(function(securedDashboardComp){
       var reasonSetPresent=false;
        var nameEmpty=false;
        var testArray=[];
        val.$rows.forEach(function(row,index) {
          if(row.$data["proposed.__name"] === undefined)
          {
           testArray.push(val.$rows[index].$subject.$propInParent.$displayName);
          }else  if((row.$data["proposed.__name"] !== ""))
          {
          testArray.push(row.$data["proposed.__name"]);
          }
        });
          var duplicates=hasDuplicates(testArray);
        if(duplicates){
            index = index +1;
            errorMessage+= "<b>"+ index +"</b>" + ". "+lex.get('reasonSet.duplicate.name')+"</br>";
        }
         val.$rows.forEach(function(row,index) {
           if(row.$data["proposed.__name"]!== undefined && row.$data["proposed.__name"] === "")
             {
             nameEmpty=true;
             }
           if(row.$data["proposed.__name"]!== undefined && securedDashboardComp.getSlot(baja.SlotPath.escape(row.$data["proposed.__name"])) !== null)
             {
                var comp=securedDashboardComp.getSlot(baja.SlotPath.escape(row.$data["proposed.__name"]));

               if((val.$componentSource.$container[index].$handle!==comp.$val.$handle))
               {
                   reasonSetPresent=true;
               }
             }
         });
         if(nameEmpty === true)
            {
              index = index +1;
              errorMessage+= "<b>"+ index +"</b>" + ". "+lex.get('specify.name.message')+"</br>";
            }
         if(reasonSetPresent === true)
           {
           index = index +1;
           errorMessage+= "<b>"+ index +"</b>" + ". "+lex.get('reason.duplicate.name')+"</br>";
           }

        val.$rows.forEach(function(row) {
           if(row.$data["proposed.reasonForChange"]!== undefined &&
           !(row.$data["proposed.reasonForChange"].length>0 && row.$data["proposed.reasonForChange"].length<=50))
            {
             invalidData=true;
            }
        });
        if(invalidData === true)
        {
        index = index +1;
        errorMessage+= "<b>"+ index +"</b>" + ". "+lex.get('mgr.validation.reasonForChange.length')+"</br>";
        }
         if(errorMessage.length>0)
         {
          dialogs.showOk({
            title: lex.get('error.title'),
            content:errorMessage
          });
           return false;
          }else
          {
           fulfill(errorMessage);
          }
       },
       function(err){
       reject(err);
       });
    });
   // editflag=editflag+1;
    }else
    {
    return new Promise( function(fulfill,reject){
    editflag=editflag+1;
    fulfill(errorMessage);
    });
    }
  };
  return ReasonEditor;
});
