/**
 * @copyright 2015 Tridium, Inc. All Rights Reserved.
 * @author Logan Byam
 */

/**
 * @private
 * @module nmodule/webEditors/rc/wb/util/user/UserManagerMgrModel
 */
define(['baja!',
        'baja!baja:PasswordAuthenticator',
        'underscore',
        'nmodule/webEditors/rc/servlets/password',
        'nmodule/webEditors/rc/wb/mgr/model/MgrModel'], function (
         baja,
         types,
         _,
         password,
         MgrModel) {

  'use strict';

  /**
   * Get component name.
   *
   * @inner
   * @param {baja.Component} comp
   * @returns {String}
   */
  /*function toName(comp) { return comp.getName(); }*/

  /**
   * `MgrModel` for the User Manager.
   *
   * @inner
   * @class
   * @extends module:nmodule/webEditors/rc/wb/mgr/model/MgrModel
   */
  var ConfigSetModel = function ConfigSetModel() {
    MgrModel.apply(this, arguments);
  };
  ConfigSetModel.prototype = Object.create(MgrModel.prototype);
  ConfigSetModel.prototype.constructor = ConfigSetModel;
  /**
   * When creating a new user, copy the default prototype off of
   * the user service. See `wbutil:UserManager$model#newInstance`.
   *
   * @param {String|baja.Value} typeSpec
   * @returns {baja.Component} a `baja:User` cloned from the default
   * prototype.
   */
  /*ConfigSetModel.prototype.newInstance = function (typeSpec) {
     return MgrModel.prototype.newInstance.apply(this, arguments);
  };*/

  /**
   * Before writing the users up to the station, wipe all the passwords off
   * (BajaScript will not encode them). After the users are added, then send
   * the passwords up through the designated `ChangeUserPasswordServlet`.
   *
   * @param {Array.<baja.Component>} users
   * @returns {Promise}
   */
/*
  ConfigSetModel.prototype.addInstances = function (users) {

    return MgrModel.prototype.addInstances.apply(this, arguments);

  };
*/

  return ConfigSetModel;
});
