/**
 * @copyright 2017 Tridium, Inc. All Rights Reserved.
 * @author Gunjan Moghe
 */

/**
 * @private
 * @module nmodule/electronicSignature/rc/wb/mgr/model/CustomerManagerMgrModel
 */
define(['baja!',
        'baja!baja:PasswordAuthenticator',
        'underscore',
        'nmodule/webEditors/rc/servlets/password',
        'nmodule/webEditors/rc/wb/mgr/model/MgrModel'], function (
         baja,
         types,
         _,
         password,
         MgrModel) {

  'use strict';

  /**
   * Get component name.
   *
   * @inner
   * @param {baja.Component} comp
   * @returns {String}
   */
 /* function toName(comp) {
  		return comp.getName(); 
  	}*/

  /**
   * `MgrModel` for the Customer Manager.
   *
   * @inner
   * @class
   * @extends module:nmodule/webEditors/rc/wb/mgr/model/MgrModel
   */
  var ZoneManagerMgrModel = function ZoneManagerMgrModel() {
    MgrModel.apply(this, arguments);
  };
  ZoneManagerMgrModel.prototype = Object.create(MgrModel.prototype);
  ZoneManagerMgrModel.prototype.constructor = ZoneManagerMgrModel;

  /**
   * When creating a new customer, create an instance of electronicSignature:Customer.
   *
   * @param {String|baja.Value} typeSpec
   * @returns {baja.Component} a `electronicSignature:Customer` instance.
   */
  ZoneManagerMgrModel.prototype.newInstance = function (typeSpec) {
    return baja.$("electronicSignature:Zone");
  };


  return ZoneManagerMgrModel;
});
