/**
 * @copyright 2015 Tridium, Inc. All Rights Reserved.
 * @author Smita Rajge
 */
define([
  'baja!',
  'bajaux/events',
  'jquery',
  'underscore',
  'Promise',
  "nmodule/webEditors/rc/wb/tree/NavTree",
  'hbs!nmodule/webEditors/rc/wb/template/NavTree',
  'nmodule/webEditors/rc/wb/tree/TreeNode',
  'nmodule/webEditors/rc/fe/fe',
  'nmodule/webEditors/rc/util/htmlUtils',
   'bajaux/dragdrop/dragDropUtils',
  'css!nmodule/electronicSignature/rc/css/js-dialog'
], function (baja, events, $, _, Promise, NavTree,tplNavTree,TreeNode,fe,htmlUtils,dragDropUtils) {

  // Use ECMAScript 5 Strict Mode
  "use strict";

  var DESTROY_EVENT = events.DESTROY_EVENT,
      LOAD_EVENT = events.LOAD_EVENT,
      MODIFY_EVENT = events.MODIFY_EVENT,

      //EXPAND_SPINNER_DELAY = 250,
      HOVER_PRELOAD_DELAY = 200;

     // mapAsync = asyncUtils.mapAsync;


   var CustomNavTree = function () {
      NavTree.apply(this, arguments);
   };

    CustomNavTree.prototype = Object.create(NavTree.prototype);
    CustomNavTree.prototype.constructor = CustomNavTree;
    CustomNavTree.SELECTED_EVENT = 'navTree:selected';
    CustomNavTree.prototype.doSave = function(){
    return this.getSelectedNodes();
   };

   CustomNavTree.prototype.doRead = function(){
     return this.getSelectedNodes();
    };

  function setSelectedEditor(tree, selectedEd) {
    if( !selectedEd.value().$navNode.getType().is("control:ControlPoint")  && !selectedEd.value().$navNode.getType().is("baja:Folder") && !selectedEd.value().$navNode.getType().is("driver:PointDeviceExt"))
   {
     //selectedEd.setSelected(false);
   }
    if (tree !== selectedEd) {
      tree.setSelected(false);
    }
     _.each(tree.$getKids(), function (kidEd) {
      setSelectedEditor(kidEd, selectedEd);
    });
  }
  function getRoot(tree) {
    var parent = tree.jq().parent().parent().data('widget');
    return parent && parent instanceof NavTree ? getRoot(parent) : tree;
  }

  function setSelectedEditorTest(tree, selectedEd) {
   if( !selectedEd.value().$navNode.getType().is("control:ControlPoint")  && !selectedEd.value().$navNode.getType().is("baja:Folder") && !selectedEd.value().$navNode.getType().is("driver:PointDeviceExt"))
       {
       selectedEd.setSelected(false);
       }
       if ((tree.isSelected()) && (tree!==selectedEd) && (!(selectedEd.value().$navNode.getType().is("control:ControlPoint")) || (!(tree.value().$navNode.getType().is("control:ControlPoint"))) ))
       {
         selectedEd.setSelected(false);
       }
     /* if ((tree.isSelected()) && (tree!=selectedEd) && ((selectedEd.value().$navNode.getType().$typeSpec!="control:NumericWritable"
      && selectedEd.value().$navNode.getType().$typeSpec!="control:EnumWritable" && selectedEd.value().$navNode.getType().$typeSpec!="control:BooleanWritable"
      && selectedEd.value().$navNode.getType().$typeSpec!="control:StringWritable"
      ) ||
      (tree.value().$navNode.getType().$typeSpec!="control:NumericWritable" && tree.value().$navNode.getType().$typeSpec!="control:EnumWritable"
      && tree.value().$navNode.getType().$typeSpec!="control:StringWritable" && tree.value().$navNode.getType().$typeSpec!="control:BooleanWritable")
      )) {
        selectedEd.setSelected(false);
      }*/
      _.each(tree.$getKids(), function (kidEd) {
     setSelectedEditorTest(kidEd, selectedEd);
       });
  }

 /**
   * Sets up initial HTML for the nav tree node.
   * @param {jQuery} dom
   */
  /**
   * Sets up initial HTML for the nav tree node.
   * @param {jQuery} dom
   */
  NavTree.prototype.doInitialize = function (dom) {
    var that = this,
        enableHoverPreload = that.$enableHoverPreload,
        preloadTicket,
        longClickDelay = 500,
        cancelMouseup = false;

    dom.html(tplNavTree())
      .addClass('NavTree')
      .toggleClass('hideRoot', !!that.properties().get('hideRoot'));

    dom.on([DESTROY_EVENT,
            LOAD_EVENT].join(' '), '.editor', false);

    dom.on(MODIFY_EVENT, '.editor', function () {
      that.setModified(true);
      return false;
    });

    //new tree node selected by the user.
    dom.on(NavTree.SELECTED_EVENT, function (e, ed, modified) {
      if (!modified) {
        //we're not just modifying an existing selection - so go up to the root
        //and wipe out all existing selections except for the one we just made.
        setSelectedEditor(getRoot(that), ed);
      }else{
        setSelectedEditorTest(getRoot(that), ed);
      }
    });

    function handleMouseSelection(e) {
      if (that.value().isSelectable()) {
        that.setSelected(!e.ctrlKey || !that.isSelected(), !!e.ctrlKey);
      }
    }

    dom.children('.display')
      .on('touchstart', function (e) {
        var $this = $(this),
            touches = e.originalEvent.touches,
            touch = touches[0];

        if (touches.length > 1) {
          //don't select/activate on a pinch zoom
          cancelMouseup = true;
          clearTimeout(that.$longClickTicket); // jshint ignore:line
        } else {
          handleMouseSelection(e);
          that.$longClickTicket = setTimeout(function () { // jshint ignore:line
            cancelMouseup = true;
            $this.trigger($.Event('mousedown', { which: 3, pageX: touch.pageX, pageY: touch.pageY }));
          }, longClickDelay);
        }
      })
      .on('touchmove', function () {
        clearTimeout(that.$longClickTicket); // jshint ignore:line
        cancelMouseup = true;
      })
      .on('mousedown', function (e) {
        if (!(that.isSelected() && !e.ctrlKey) && !cancelMouseup) {
          handleMouseSelection(e);
          cancelMouseup = true;
        }
      })
      .on('touchend', function (e) {
        var multitouch = e.originalEvent.touches.length > 1;

        clearTimeout(that.$longClickTicket); // jshint ignore:line
        if (!cancelMouseup && !multitouch) {
          that.trigger(NavTree.ACTIVATED_EVENT, that);
        }

        //if we swallow the mouseup, also prevent it from bubbling
        var result = !cancelMouseup;
        cancelMouseup = false;
        return result;
      })
      .on('mouseup', function (e) {
        if (!cancelMouseup) {
          handleMouseSelection(e);
        }
        cancelMouseup = false;
      })
      .on('dblclick', function (e) {
        if (that.value().isSelectable()) {
          that.trigger(NavTree.ACTIVATED_EVENT, that);
          return false;
        }
      })
      .on('dragstart', function (e) {
        var node = that.value(),
            values = _.map(getRoot(that).getSelectedNodes(), function (node) {
              return node.value();
            });

        if (node.isDraggable()) {
          var clipboard = e.originalEvent.dataTransfer,
              mime = 'niagara/navnodes';

          dragDropUtils.toClipboard(clipboard, mime, values);
        }
      })
      .on('dragover dragenter', function (e) {
        if (that.value().isDropTarget()) {
          e.preventDefault();
        }
      })
      .on('drop', function (e) {
        var node = that.value();
        if (node.isDropTarget()) {
          var clipboard = e.originalEvent.dataTransfer;
          dragDropUtils.fromClipboard(clipboard)
            .then(function (envelope) {
              return envelope.toValues();
            })
            .then(function (values) {
              node.doDrop(values);
            });
          return false;
        }
      });

    dom.children('button')
      .on('click', function () {
        var p;

        if (that.$isExpanded()) {
          that.$disableTicket = setTimeout(function () { // jshint ignore:line
            that.$setKidsLoaded(false);
          }, that.$getUnloadTimeout());

          p = that.collapse();
        } else {
          clearTimeout(that.$disableTicket); // jshint ignore:line
          p = that.expand();
        }

        p.catch(baja.error);
      });

    if (enableHoverPreload) {
      dom.children('button')
        .on('mouseenter', function () {
          preloadTicket = setTimeout(function () { // jshint ignore:line
            that.$setLoaded(true);
          }, HOVER_PRELOAD_DELAY);
        })
        .on('mouseleave', function () {
          clearTimeout(preloadTicket); // jshint ignore:line
        });
    }
  };

 return CustomNavTree;
});
