/**
 * @copyright 2017 Tridium, Inc. All Rights Reserved.
 * @author Smita Rajge
 */

/**
 * PointChooserTreeNode is a custom TreeNode that displays only certain valid types of components
 *
 * @module nmodule/gafGateway/rc/wizards/gateway/GatewayTreeNode
 * @private
 */
define([
  'baja!',
  'baja!driver:Device,driver:DeviceFolder,driver:PointDeviceExt,driver:PointFolder,control:ControlPoint',
  'jquery',
  'underscore',
  'Promise',
  'nmodule/webEditors/rc/wb/tree/BajaNavTreeNode'
], function (baja,
             types,
             $, _,
             Promise,
             BajaNavTreeNode) {

  // Use ECMAScript 5 Strict Mode
  "use strict";
 /*Check if the component is of valid type to show in ord chooser */
function isValidType(component)
{
  var result = false;
  if(component.getType().is("baja:Component"))
     {
         if(component.getType().is("electronicSignature:SecuredBooleanWritable") || component.getType().is("electronicSignature:SecuredBooleanPoint") || component.getType().is("electronicSignature:SecuredEnumWritable")  || component.getType().is("electronicSignature:SecuredEnumPoint") || component.getType().is("electronicSignature:SecuredNumericWritable") || component.getType().is("electronicSignature:SecuredNumericPoint") || component.getType().is("electronicSignature:SecuredStringWritable") || component.getType().is("electronicSignature:SecuredStringPoint"))
         {
            return false;
         }else if(component.getType().getTypeName().equals("BooleanWritable") || component.getType().getTypeName().equals("BooleanPoint") || component.getType().getTypeName().equals("EnumWritable") || component.getType().getTypeName().equals("EnumPoint") || component.getType().getTypeName().equals("NumericWritable") || component.getType().getTypeName().equals("NumericPoint") || component.getType().getTypeName().equals("StringWritable") || component.getType().getTypeName().equals("StringPoint")){
             if((component.getType().getTypeName().equals("BooleanPoint") || component.getType().getTypeName().equals("EnumPoint") || component.getType().getTypeName().equals("NumericPoint") || component.getType().getTypeName().equals("StringPoint")) && !(component.getProxyExt().getType().is("control:NullProxyExt"))) {
                 return false;
             }else{
                 return true;
             }
         }
         if((component.getType().is("driver:DriverContainer")) || (component.getType().is("driver:DeviceNetwork")) || (component.getName()=== "networkInputs") || (component.getName() === "virtualPoints") || (component.getName() ==="subModules") || (component.getName() === "points") || (component.getName() ==="inputs") || (component.getName()=== "outputs"))
         {
             result = true;
         }
         else if(component.getType().is("driver:Device"))
         {
             if(component.getType().getTypeName().equals("DeviceLSE"))
             {
                 result = true;
             }else
             {
                 var pointsProp = component.getSlot("points");
                 var inputsProp = component.getSlot("inputs");
                  var outputProp = component.getSlot("outputs");
                 if(pointsProp !== null)
                 {
                    component = pointsProp;
                 }
                if(inputsProp !== null)
                 {
                     component=inputsProp;
                 }
                if(outputProp !== null)
                 {
                     component= outputProp;
                 }
                 if((component.getType().is("driver:PointDeviceExt")) || (component.getType().is("driver:PointFolder")))
                 {
                     result = true;

                 }
             }
         }else if(component.getType().is("baja:Folder")){
             result =true;
         }

     }
    return result;
}
  var PointChooserTreeNode = function () {
    BajaNavTreeNode.apply(this, arguments);
  };

  PointChooserTreeNode.prototype = Object.create(BajaNavTreeNode.prototype);
  PointChooserTreeNode.prototype.constructor = PointChooserTreeNode;

  PointChooserTreeNode.prototype.$loadKids = function (params) {
    var navKids;
    var that             = this,
    navNode          = that.value(),
    batch            = params && params.batch,
    progressCallback = (params && params.progressCallback) || _.noop,
    prom             = Promise.resolve(navNode.getNavChildren({batch: batch}))
    .then(function(navTreeKids){
         navKids= navTreeKids;
         var loadKidsPromise = [];
         for(var i=0;i<navTreeKids.length;i++)
         {
         loadKidsPromise.push(navTreeKids[i].loadSlots());
         }
         return Promise.all(loadKidsPromise);
    })
    .then(function (loadedKids) {
        return _.compact(_.map(navKids, function (navKid) {
          return isValidType(navKid) ? new PointChooserTreeNode(navKid) : null;
         }));
    });

    progressCallback('commitReady');
    return prom;
  };

    return PointChooserTreeNode;
});
