package com.secured.ui.mgr.alarm.hx;

//
// Source code recreated from a .class file by IntelliJ IDEA
// (powered by Fernflower decompiler)
//

import com.secured.alarm.BProtectedConsoleRecipient;
import com.tridium.bql.filter.BAbsTimeFilter;
import com.tridium.bql.util.BDynamicTimeRange;

import javax.baja.alarm.*;
import javax.baja.collection.BITable;
import javax.baja.collection.ColumnList;
import javax.baja.collection.TableCursor;
import javax.baja.gx.BImage;
import javax.baja.hx.*;
import javax.baja.io.HtmlWriter;
import javax.baja.naming.BOrd;
import javax.baja.naming.BOrdList;
import javax.baja.naming.SlotPath;
import javax.baja.nre.annotations.AgentOn;
import javax.baja.nre.annotations.NiagaraSingleton;
import javax.baja.nre.annotations.NiagaraType;
import javax.baja.nre.util.SortUtil;
import javax.baja.nre.util.TextUtil;
import javax.baja.security.BPermissions;
import javax.baja.security.PermissionException;
import javax.baja.sys.*;
import javax.baja.util.BFormat;
import javax.baja.util.BUuid;
import javax.baja.util.Lexicon;
import javax.baja.xml.XWriter;
import java.io.IOException;
import java.util.*;
import java.util.logging.Level;

@Deprecated
@NiagaraType(agent = @AgentOn(types = {"electronicSignature:ProtectedWbAlarmConsole"}, requiredPermissions = "rw", defaultAgent = AgentOn.Preference.PREFERRED))
@NiagaraSingleton
public class BProtectedHxAlarmConsoleView extends BHxView {
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.secured.ui.mgr.alarm.hx.BProtectedHxAlarmConsoleView(4056150521)1.0$ @*/
/* Generated Thu Dec 20 13:01:25 IST 2018 by Slot-o-Matic (c) Tridium, Inc. 2012 */
  
  public static final BProtectedHxAlarmConsoleView INSTANCE = new BProtectedHxAlarmConsoleView();

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////

  @Override
  public Type getType()
  {
    return TYPE;
  }

  public static final Type TYPE = Sys.loadType(BProtectedHxAlarmConsoleView.class);

  /*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/
  BAlarmService alarmService;
  public static final Lexicon lexicon = Lexicon.make(BProtectedHxAlarmConsoleView.class);
  public static final BFacets HX_TIMESTAMP_FACETS;
  private static BImage yellowAlarmImg;
  private static BImage redAlarmImg;
  private static BImage greenAlarmImg;
  private static BImage orangeAlarmImg;
  private static BImage sortAsc;
  private static BImage sortDesc;
  private static BImage arrow;
  private static BImage linkImg;
  private static BImage blankImg;
  public String sheetClass = "window-bg hx-AlarmConsole";
  public String headClass = "window-bg control-border font hx-AlarmConsole-header";
  public String rowClass = "window-bg control-border hx-AlarmConsole-row";
  public AlarmCommand acknowledge;
  public AlarmCommand forceClear;
  public AlarmCommand showRecurring;
  public AlarmCommand showAll;
  public AlarmCommand showDetails;
  public AlarmCommand addNotes;
  public Command sort;

  protected BProtectedHxAlarmConsoleView()
  {
    this.registerEvent(this.acknowledge = new Acknowledge(this));
    this.registerEvent(this.showRecurring = new ShowRecurring(this));
    this.registerEvent(this.showAll = new ShowAll(this));
    this.registerEvent(this.showDetails = new ShowDetails(this));
    this.registerEvent(this.forceClear = new ForceClear(this));
    this.registerEvent(this.sort = new SortCommand(this));
    this.registerEvent(this.addNotes = new AddNotes(this));
  }

  private <T extends javax.baja.sys.BIObject> BITable<T> getObjects()
  {
    try
    {
      return (BITable<T>) BOrd.make("station:|slot:/|bql:select handle from electronicSignature:SecuredDashboardConfiguration").get();
    }
    catch (Exception e)
    {
      log.log(Level.SEVERE, "Exception in getObjects:", e);
    }
    return null;
  }

  private String getDashboardHandle()
  {
    BITable dataTable = getObjects();
    ColumnList columns = dataTable.getColumns();

    String handle = "";
    try (TableCursor<BIObject> cursor = dataTable.cursor())
    {
      if (cursor.next())
      {
        handle = cursor.cell(columns.get(0)).toString();
      }
    }
    catch (Exception e)
    {
      log.log(Level.SEVERE, "Exception in Alarm Hx View get Dashboard Handle:", e);
    }
    return handle;
  }


  public void write(HxOp op)
    throws Exception
  {
    HtmlWriter out = op.getHtmlWriter();
    op.setDynamic();
    op.addJavaScript("module://alarm/com/tridium/alarm/hx/alarm.js");
    op.addJavaScript("module://electronicSignature/com/secured/ui/mgr/alarm/hx/authentication.js");
    op.addStyleSheet("module://alarm/com/tridium/alarm/hx/alarm.css");
    BDynamicEnum theme = (BDynamicEnum) op.getWebOp().getProfileConfig().get("selectedHxTheme");
    String themeName = theme == null ? null : theme.getTag();
    if (themeName != null && !themeName.isEmpty())
    {
      op.addStyleSheet("module://theme" + themeName + "/ux/theme.css");
    }

    out.w("<div class=\"alarmconsole-background\">");
    out.w("<table height='100%' width='100%' cellspacing='0' cellpadding='0' >");
    out.w("<tr><td>");
    out.w("<div id=\"" + op.scope("tableTitle") + "\"class=\"ux-table ux-table-head\">");
    this.writeTableTitle(false, op);
    out.w("</div>");
    out.w("</td></tr>");
    out.w("<tr><td valign='top' height='100%' >");
    out.w("<div id=\"" + op.scope("tableRecords") + "\"");
    out.w(" style=\"overflow:auto; width:100%;\"");
    out.w(">");
    out.w("<table width=\"100%\" cellspacing=\"0\" class=\"ux-table\" id=\"" + op.scope("records") + "\">");
    this.writeTableHeader(op, false);
    out.w("<tr><td colspan=\"9\">Loading...</td></tr>");
    out.w("</table></div>");
    out.w("</td></tr>");
    out.w("<tr class=\"ux-table-row\"><td>");
    out.w("<div style=\"padding:10px; align:center; text-align:center;\" id=\"" + op.scope("commands") + "\">");
    out.w("</div>");
    out.w("</td></tr>");
    out.w("</table>");
    out.w("<input type=\"hidden\" id=\"hiddenNotes\" name=\"hiddenNotes\" \\>");
    out.w("</div>");
    out.w("<input type=\"hidden\" id=\"hiddenEsignHandle\" value=\"" + getDashboardHandle() + "\">");
    op.addOnload(this.sort.getInvokeCode(op));
  }

  public void update(HxOp op)
    throws Exception
  {
    super.update(op);
  }

  private String addTimeRangeFilter(BProtectedConsoleRecipient recip, String query)
  {
    BDynamicTimeRange timeRange = recip.getDefaultTimeRange();
    if (!timeRange.equals(BDynamicTimeRange.DEFAULT))
    {
      BAbsTimeFilter timeFilter = new BAbsTimeFilter();
      timeFilter.initFromDynamicTimeRange(timeRange);
      String predicate = timeFilter.getPredicate(BAlarmRecord.timestamp.getName());
      if (predicate != null && !predicate.isEmpty())
      {
        return query + " and " + predicate;
      }
    }

    return query;
  }

  public void showAll(HxOp op)
    throws Exception
  {
    BProtectedConsoleRecipient recip = (BProtectedConsoleRecipient) op.get();
    String query = recip.getInitialAlarmQuery(op.getUser());
    query = this.addTimeRangeFilter(recip, query);
    BOrd ord = BOrd.make(query);
    BITable<BAlarmRecord> result = (BITable) ord.resolve(recip).get();
    HashMap<BOrdList, SourceAlarm> sources = new HashMap();
    Cursor<BAlarmRecord> cur = result.cursor();
    Throwable var8 = null;

    SourceAlarm rec;
    try
    {
      while (cur.next())
      {
        BAlarmRecord alarm = (BAlarmRecord) cur.get();
        BOrdList alarmSource = alarm.getSource();
        rec = null;
        if (sources.containsKey(alarmSource))
        {
          rec = (SourceAlarm) sources.get(alarmSource);
        }
        else
        {
          rec = new SourceAlarm();
        }

        rec.update((BAlarmRecord) alarm.newCopy());
        sources.put(alarm.getSource(), rec);
      }
    }
    catch (Throwable var21)
    {
      var8 = var21;
      throw var21;
    }
    finally
    {
      if (cur != null)
      {
        if (var8 != null)
        {
          try
          {
            cur.close();
          }
          catch (Throwable var19)
          {
            var8.addSuppressed(var19);
          }
        }
        else
        {
          cur.close();
        }
      }

    }

    List<SourceAlarm> alarms = new ArrayList(sources.values());
    String sortCol = "timestamp";
    boolean sortAscending = false;
    if (op.getUnsafePostBody() != null)
    {
      if (op.getFormValue("sortBy") != null)
      {
        sortCol = op.getFormValue("sortBy");
      }

      try
      {
        sortAscending = Boolean.parseBoolean(op.getFormValue("sortAscending"));
      }
      catch (Exception var20)
      {
        var20.printStackTrace();
      }
    }

    if (sortAscending)
    {
      this.sortSourceAlarms(alarms, sortCol, SortUtil.ASCENDING);
    }
    else
    {
      this.sortSourceAlarms(alarms, sortCol, SortUtil.DESCENDING);
    }

    this.writeTableHeader(op, true);

    for (int i = 0; i < alarms.size(); ++i)
    {
      rec = (SourceAlarm) alarms.get(i);
      BAlarmRecord alarm = rec.alarm;
      this.writeAlarmRow(op, alarm, rec);
    }

  }

  public void writeCommands(AlarmCommand[] cmds, HxOp op)
    throws Exception
  {
    HtmlWriter out = op.getHtmlWriter();

    for (int i = 0; i < cmds.length; ++i)
    {

      if (cmds[i] instanceof Acknowledge || cmds[i] instanceof ForceClear)
      {
        out.w("<span class=\"ux-btn\"").w(" onclick=\"").w("processAuthenticatedAlarms(this)\"").w(" data-onclick=\"").w(cmds[i].getInvokeCode(op)).w("\">");
      }
      else
      {
        out.w("<span class=\"ux-btn\"").w(" onclick=\"").w(cmds[i].getInvokeCode(op)).w("\">");
      }
      if (cmds[i].getIcon(op) != null)
      {
        HxUtil.makeImage(cmds[i].getIcon(op), (String) null, (String) null, "\"", op);
        out.w("&nbsp;");
      }

      out.safe(cmds[i].getDisplayName(op));
      out.w("</span>&nbsp;");
    }
    out.w("<input type=\"hidden\" id=\"hiddenButton\" \\>");
  }

  public void ackAlarmByUuid(String uuid, String notes, HxOp op)
    throws Exception
  {
    if (uuid != null)
    {
      BOrd ord = BOrd.make("alarm:|bql:select * from openAlarms where uuid = Uuid '" + uuid + "'");
      BITable<BAlarmRecord> result = (BITable) ord.resolve(op.get()).get();
      List<BAlarmRecord> arr = new ArrayList();
      Cursor<BAlarmRecord> cur = result.cursor();
      Throwable var8 = null;

      try
      {
        while (cur.next())
        {
          arr.add((BAlarmRecord) ((BAlarmRecord) cur.get()).newCopy());
        }
      }
      catch (Throwable var17)
      {
        var8 = var17;
        throw var17;
      }
      finally
      {
        if (cur != null)
        {
          if (var8 != null)
          {
            try
            {
              cur.close();
            }
            catch (Throwable var16)
            {
              var8.addSuppressed(var16);
            }
          }
          else
          {
            cur.close();
          }
        }

      }

      for (int j = 0; j < arr.size(); ++j)
      {
        this.ackAlarm((BAlarmRecord) arr.get(j), notes, op);
      }

    }
  }

  public void addAlarmNoteByUuid(String uuid, String notes, HxOp op)
    throws AlarmException, IOException
  {
    if (uuid != null)
    {
      BOrd ord = BOrd.make("alarm:|bql:select * from openAlarms where uuid = Uuid '" + uuid + "'");
      BITable<BAlarmRecord> result = (BITable) ord.resolve(op.get()).get();
      List<BAlarmRecord> arr = new ArrayList();
      Cursor<BAlarmRecord> cur = result.cursor();
      Throwable var8 = null;

      try
      {
        while (cur.next())
        {
          arr.add((BAlarmRecord) ((BAlarmRecord) cur.get()).newCopy());
        }
      }
      catch (Throwable var33)
      {
        var8 = var33;
        throw var33;
      }
      finally
      {
        if (cur != null)
        {
          if (var8 != null)
          {
            try
            {
              cur.close();
            }
            catch (Throwable var29)
            {
              var8.addSuppressed(var29);
            }
          }
          else
          {
            cur.close();
          }
        }

      }

      AlarmDbConnection conn = this.getAlarmService().getAlarmDb().getDbConnection((Context) null);
      var8 = null;

      try
      {
        for (int j = 0; j < arr.size(); ++j)
        {
          BAlarmRecord alarm = (BAlarmRecord) arr.get(j);
          this.addNotes(alarm, notes, op);
          conn.update(alarm);
        }
      }
      catch (Throwable var31)
      {
        var8 = var31;
        throw var31;
      }
      finally
      {
        if (conn != null)
        {
          if (var8 != null)
          {
            try
            {
              conn.close();
            }
            catch (Throwable var30)
            {
              var8.addSuppressed(var30);
            }
          }
          else
          {
            conn.close();
          }
        }

      }

    }
  }

  public void ackAlarmBySource(String src, String notes, HxOp op)
    throws Exception
  {
    if (src != null)
    {
      BOrd ord = BOrd.make("alarm:|bql:select * from openAlarms where source = OrdList '" + src + "'");
      BITable<BAlarmRecord> result = (BITable) ord.resolve(op.get()).get();
      List<BAlarmRecord> arr = new ArrayList();
      Cursor<BAlarmRecord> cur = result.cursor();
      Throwable var8 = null;

      try
      {
        while (cur.next())
        {
          arr.add((BAlarmRecord) ((BAlarmRecord) cur.get()).newCopy());
        }
      }
      catch (Throwable var17)
      {
        var8 = var17;
        throw var17;
      }
      finally
      {
        if (cur != null)
        {
          if (var8 != null)
          {
            try
            {
              cur.close();
            }
            catch (Throwable var16)
            {
              var8.addSuppressed(var16);
            }
          }
          else
          {
            cur.close();
          }
        }

      }

      for (int j = 0; j < arr.size(); ++j)
      {
        this.ackAlarm((BAlarmRecord) arr.get(j), notes, op);
      }

    }
  }

  public void addAlarmNoteBySource(String src, String notes, HxOp op)
    throws AlarmException, IOException
  {
    if (src != null)
    {
      BOrd ord = BOrd.make("alarm:|bql:select * from openAlarms where source = OrdList '" + src + "'");
      BITable<BAlarmRecord> result = (BITable) ord.resolve(op.get()).get();
      List<BAlarmRecord> arr = new ArrayList();
      Cursor<BAlarmRecord> cur = result.cursor();
      Throwable var8 = null;

      try
      {
        while (cur.next())
        {
          arr.add((BAlarmRecord) ((BAlarmRecord) cur.get()).newCopy());
        }
      }
      catch (Throwable var33)
      {
        var8 = var33;
        throw var33;
      }
      finally
      {
        if (cur != null)
        {
          if (var8 != null)
          {
            try
            {
              cur.close();
            }
            catch (Throwable var30)
            {
              var8.addSuppressed(var30);
            }
          }
          else
          {
            cur.close();
          }
        }

      }

      AlarmDbConnection conn = this.getAlarmService().getAlarmDb().getDbConnection((Context) null);
      var8 = null;

      try
      {
        for (int j = 0; j < arr.size(); ++j)
        {
          BAlarmRecord alarm = (BAlarmRecord) arr.get(j);
          this.addNotes(alarm, notes, op);
          conn.update(alarm);
        }
      }
      catch (Throwable var31)
      {
        var8 = var31;
        throw var31;
      }
      finally
      {
        if (conn != null)
        {
          if (var8 != null)
          {
            try
            {
              conn.close();
            }
            catch (Throwable var29)
            {
              var8.addSuppressed(var29);
            }
          }
          else
          {
            conn.close();
          }
        }

      }

    }
  }

  public void ackAlarm(BAlarmRecord alarm, String notes, HxOp op)
    throws Exception
  {
    BAlarmClass alarmClass = this.getAlarmService().lookupAlarmClass(alarm.getAlarmClass());
    if (alarmClass == null)
    {
      alarmClass = this.getAlarmService().getDefaultAlarmClass();
    }

    op.getUser().check(alarmClass, BPermissions.operatorWrite);
    alarm.setUser(op.getUser().getUsername());
    alarm.setAckTime(BAbsTime.now());
    alarm.setAckState(BAckState.ackPending);
    this.addNotes(alarm, notes, op);
    AlarmDbConnection conn = this.getAlarmService().getAlarmDb().getDbConnection((Context) null);
    Throwable var6 = null;

    try
    {
      BAlarmRecord rec = conn.getRecord(alarm.getUuid());
      if (rec == null || rec.getAckState() != BAckState.ackPending)
      {
        conn.update(alarm);
      }
    }
    catch (Throwable var15)
    {
      var6 = var15;
      throw var15;
    }
    finally
    {
      if (conn != null)
      {
        if (var6 != null)
        {
          try
          {
            conn.close();
          }
          catch (Throwable var14)
          {
            var6.addSuppressed(var14);
          }
        }
        else
        {
          conn.close();
        }
      }

    }

    this.getAlarmService().ackAlarm(alarm);
  }

  protected void addNotes(BAlarmRecord rec, String newNotes, HxOp op)
  {
    if (newNotes != null)
    {
      BFacets alarmData = rec.getAlarmData();
      String oldNotes = "";
      if (alarmData.get("notes") != null)
      {
        oldNotes = alarmData.get("notes").toString();
      }

      StringBuffer notes = new StringBuffer();
      notes.append("## " + BAbsTime.now() + " - " + op.getUser().getUsername() + " ##\n");
      notes.append(newNotes);
      notes.append("\n\n");
      notes.append(oldNotes);
      BFacets f = BFacets.make(alarmData, BFacets.make("notes", BString.make(notes.toString())));
      rec.setAlarmData(f);
    }
  }

  public void forceClearBySource(String src, String alarmNotes, HxOp op)
    throws Exception
  {
    BOrd ord = BOrd.make("alarm:|bql:select * from openAlarms where source = OrdList '" + src + "'");
    BITable<BAlarmRecord> result = (BITable) ord.resolve(op.get()).get();
    List<BAlarmRecord> arr = new ArrayList();
    Cursor<BAlarmRecord> cur = result.cursor();
    Throwable var7 = null;

    try
    {
      while (cur.next())
      {
        arr.add((BAlarmRecord) ((BAlarmRecord) cur.get()).newCopy());
      }
    }
    catch (Throwable var39)
    {
      var7 = var39;
      throw var39;
    }
    finally
    {
      if (cur != null)
      {
        if (var7 != null)
        {
          try
          {
            cur.close();
          }
          catch (Throwable var33)
          {
            var7.addSuppressed(var33);
          }
        }
        else
        {
          cur.close();
        }
      }

    }

    try
    {
      for (int j = 0; j < arr.size(); ++j)
      {
        BAlarmRecord alarm = (BAlarmRecord) arr.get(j);
        BAlarmClass alarmClass = this.getAlarmService().lookupAlarmClass(alarm.getAlarmClass());
        if (alarmClass == null)
        {
          alarmClass = this.getAlarmService().getDefaultAlarmClass();
        }

        op.getUser().check(alarmClass, BPermissions.adminWrite);
        alarm.setUser(op.getUser().getUsername());
        alarm.setAckTime(BAbsTime.now());
        alarm.setAckState(BAckState.acked);
        alarm.setSourceState(BSourceState.normal);
        alarm.addAlarmFacet("forceCleared", BString.make(op.getUser().getUsername()));
        this.addNotes(alarm, alarmNotes, op);

        AlarmDbConnection conn = this.getAlarmService().getAlarmDb().getDbConnection((Context) null);
        Throwable var10 = null;

        try
        {
          conn.update(alarm);
        }
        catch (Throwable var35)
        {
          var10 = var35;
          throw var35;
        }
        finally
        {
          if (conn != null)
          {
            if (var10 != null)
            {
              try
              {
                conn.close();
              }
              catch (Throwable var34)
              {
                var10.addSuppressed(var34);
              }
            }
            else
            {
              conn.close();
            }
          }

        }

        this.getAlarmService().invoke(BAlarmService.auditForceClear, alarm, op);
      }
    }
    catch (PermissionException var37)
    {
      System.out.println("Invalid Permissions");
    }
    catch (Exception var38)
    {
      System.out.println("Cannot find: " + src);
    }

  }

  public void forceClearByUuid(String uuid, String alarmNotes, HxOp op)
    throws Exception
  {
    BOrd ord = BOrd.make("alarm:|bql:select * from openAlarms where uuid = Uuid '" + uuid + "'");
    BITable<BAlarmRecord> result = (BITable) ord.resolve(op.get()).get();
    List<BAlarmRecord> arr = new ArrayList();
    Cursor<BAlarmRecord> cur = result.cursor();
    Throwable var7 = null;

    try
    {
      while (cur.next())
      {
        arr.add((BAlarmRecord) ((BAlarmRecord) cur.get()).newCopy());
      }
    }
    catch (Throwable var39)
    {
      var7 = var39;
      throw var39;
    }
    finally
    {
      if (cur != null)
      {
        if (var7 != null)
        {
          try
          {
            cur.close();
          }
          catch (Throwable var33)
          {
            var7.addSuppressed(var33);
          }
        }
        else
        {
          cur.close();
        }
      }

    }

    try
    {
      for (int j = 0; j < arr.size(); ++j)
      {
        BAlarmRecord alarm = (BAlarmRecord) arr.get(j);
        BAlarmClass alarmClass = this.getAlarmService().lookupAlarmClass(alarm.getAlarmClass());
        if (alarmClass == null)
        {
          alarmClass = this.getAlarmService().getDefaultAlarmClass();
        }

        op.getUser().check(alarmClass, BPermissions.adminWrite);
        alarm.setUser(op.getUser().getUsername());
        alarm.setAckTime(BAbsTime.now());
        alarm.setAckState(BAckState.acked);
        alarm.setSourceState(BSourceState.normal);
        alarm.addAlarmFacet("forceCleared", BString.make(op.getUser().getUsername()));
        this.addNotes(alarm, alarmNotes, op);
        AlarmDbConnection conn = this.getAlarmService().getAlarmDb().getDbConnection((Context) null);
        Throwable var10 = null;

        try
        {
          conn.update(alarm);
        }
        catch (Throwable var35)
        {
          var10 = var35;
          throw var35;
        }
        finally
        {
          if (conn != null)
          {
            if (var10 != null)
            {
              try
              {
                conn.close();
              }
              catch (Throwable var34)
              {
                var10.addSuppressed(var34);
              }
            }
            else
            {
              conn.close();
            }
          }

        }

        this.getAlarmService().invoke(BAlarmService.auditForceClear, alarm, op);
      }
    }
    catch (PermissionException var37)
    {
      System.out.println("Invalid Permissions");
    }
    catch (Exception var38)
    {
      System.out.println("Cannot find: " + uuid);
    }

  }

  protected void writeTableTitle(boolean recurring, HxOp op)
    throws Exception
  {
    HtmlWriter out = op.getHtmlWriter();
    out.w("<span class=\"alarmConsole-title\">").safe(lexicon.getText("HxAlarmConsole.displayName")).w("</span>");
    if (recurring)
    {
      out.w("<span class=\"alarmConsole-title\">&nbsp;");
      HxUtil.makeImage(arrow, (String) null, (String) null, "\"", op);
      out.w("&nbsp;").safe(lexicon.getText("hx.recurringAlarms")).w("</span>");
    }

  }

  public void showRecurringAlarms(String src, HxOp op)
    throws Exception
  {
    HtmlWriter out = op.getHtmlWriter();
    BProtectedConsoleRecipient recip = (BProtectedConsoleRecipient) op.get();
    String query = recip.getInitialAlarmQuery(op.getUser());
    query = query + " and source='" + src + "'";
    query = this.addTimeRangeFilter(recip, query);
    BOrd ord = BOrd.make(query);
    BITable<BAlarmRecord> result = (BITable) ord.resolve(recip).get();
    List<BAlarmRecord> alarmArray = new ArrayList();
    Cursor<BAlarmRecord> cur = result.cursor();
    Throwable var10 = null;

    try
    {
      while (cur.next())
      {
        alarmArray.add((BAlarmRecord) ((BAlarmRecord) cur.get()).newCopy());
      }
    }
    catch (Throwable var22)
    {
      var10 = var22;
      throw var22;
    }
    finally
    {
      if (cur != null)
      {
        if (var10 != null)
        {
          try
          {
            cur.close();
          }
          catch (Throwable var20)
          {
            var10.addSuppressed(var20);
          }
        }
        else
        {
          cur.close();
        }
      }

    }

    String sortCol = "timestamp";
    boolean sortAscending = false;
    if (op.getUnsafePostBody() != null)
    {
      if (op.getFormValue("sortBy") != null)
      {
        sortCol = op.getFormValue("sortBy");
      }

      try
      {
        sortAscending = Boolean.parseBoolean(op.getFormValue("sortAscending"));
      }
      catch (Exception var21)
      {
      }
    }

    if (sortAscending)
    {
      this.sortAlarms(alarmArray, sortCol, SortUtil.ASCENDING);
    }
    else
    {
      this.sortAlarms(alarmArray, "timestamp", SortUtil.DESCENDING);
    }

    out.w("<input type=\"hidden\" name=\"" + op.scope("recurringAlarms") + "\" value=\"true\" />");
    out.w("<input type=\"hidden\" name=\"" + op.scope("source") + "\" value=\"" + src + "\" />");
    this.writeTableHeader(op, true);

    for (int i = 0; i < alarmArray.size(); ++i)
    {
      BAlarmRecord alarm = (BAlarmRecord) alarmArray.get(i);
      BString source = (BString) alarm.getAlarmData().get("sourceName");
      if (source == null)
      {
        source = BString.make(alarm.getSource().toString());
      }

      BString msg = (BString) alarm.getAlarmData().get("msgText");
      if (msg == null)
      {
        msg = BString.make("");
      }

      this.writeAlarmRow(op, alarm, (SourceAlarm) null);
    }

  }

  protected void writeTableHeader(HxOp op, boolean showJs)
    throws Exception
  {
    HtmlWriter out = op.getHtmlWriter();
    out.w("<thead class=\"ux-table-head\">");
    out.w("<tr>");
    out.w("<th>");
    out.w("<input type=\"checkbox\" onclick=\"ac.selectAll(event);\"/>");
    out.w("</th>");
    out.w("<th>&nbsp;</th>");
    this.writeColumnHeader(op, BAlarmRecord.timestamp, showJs);
    this.writeColumnHeader(op, BAlarmRecord.source, showJs);
    this.writeColumnHeader(op, BAlarmRecord.sourceState, showJs);
    this.writeColumnHeader(op, BAlarmRecord.ackState, showJs);
    this.writeColumnHeader(op, BAlarmRecord.priority, showJs);
    this.writeColumnHeader(op, BAlarmRecord.alarmClass, showJs);
    out.w("<th>Message</th>");
    out.w("</tr>");
    out.w("</thead>");
  }

  protected void writeColumnHeader(HxOp op, Property p, boolean showJs)
    throws Exception
  {
    HtmlWriter out = op.getHtmlWriter();
    String sortCol = "timestamp";
    boolean sortAscending = false;
    if (op.getUnsafePostBody() != null)
    {
      if (op.getFormValue("sortBy") != null)
      {
        sortCol = op.getFormValue("sortBy");
      }

      try
      {
        sortAscending = Boolean.parseBoolean(op.getFormValue("sortAscending"));
      }
      catch (Exception var8)
      {
      }
    }

    out.w("<th>");
    boolean writeSort = false;
    if (p.getName().equals(sortCol))
    {
      writeSort = !sortAscending;
    }

    out.w("<span style=\"cursor: pointer; cursor: hand;\" ");
    if (showJs)
    {
      out.w("onclick=\"hx.setFormValue(&quot;" + op.scope("sortBy") + "&quot;,&quot;" + p.getName() + "&quot;);hx.setFormValue(&quot;" + op.scope("sortAscending") + "&quot;,&quot;" + writeSort + "&quot;);hx.fireEvent(&quot;" + op.getPath() + "&quot;,&quot;" + this.sort.getId() + "&quot;);\"");
    }

    out.w(">");
    out.safe(p.getDefaultDisplayName(op));
    if (p.getName().equals(sortCol))
    {
      if (sortAscending)
      {
        HxUtil.makeImage(sortAsc, (String) null, (String) null, "\"", op);
      }
      else
      {
        HxUtil.makeImage(sortDesc, (String) null, (String) null, "\"", op);
      }
    }

    out.w("</span>");
    out.w("</th>");
  }

  protected void writeAlarmRow(HxOp op, BAlarmRecord alarm, SourceAlarm rec)
    throws Exception
  {
    HtmlWriter out = op.getHtmlWriter();
    BString source = (BString) alarm.getAlarmData().get("sourceName");
    if (source == null)
    {
      source = BString.make(alarm.getSource().toString());
    }

    BString msg = (BString) alarm.getAlarmData().get("msgText");
    if (msg == null)
    {
      msg = BString.make("");
    }

    BFormat msgFormat = BFormat.make(msg.toString());
    String msgText = msgFormat.format(alarm);
    BImage img = greenAlarmImg;
    if (alarm.getSourceState() == BSourceState.alert)
    {
      img = orangeAlarmImg;
    }
    else if (alarm.isAcknowledged() && !alarm.isNormal())
    {
      img = yellowAlarmImg;
    }
    else if (!alarm.isAcknowledged() && !alarm.isNormal())
    {
      img = redAlarmImg;
    }

    String rowClass = "ux-table-row";
    out.w("<tr class=\"" + rowClass + "\">");
    out.w("<td align=\"center\" valign=\"middle\" style=\"padding:0;\">");
    out.w("<input type=checkbox ");
    out.w("id=\"" + op.scope(alarm.getUuid().toString()) + "\" ");
    out.w("name=\"" + op.scope("_" + alarm.getUuid().toString()) + "\" ");
    out.w("value=\"" + SlotPath.escape(alarm.getSource().encodeToString()) + "\">");
    out.w("</td>");
    out.w("<td align=\"right\">");
    BImage cameraIcon;
    if (alarm.getAlarmData().get("icon") != null)
    {
      cameraIcon = BImage.make(BOrd.make(((BComponent) op.get()).getNavOrd(), alarm.getAlarmData().get("icon").toString()));
      HxUtil.makeImage(cameraIcon, (String) null, (String) null, "\"", op);
    }

    if (alarm.getAlarmData().get("hyperlinkOrd") != null)
    {
      this.makeAlarmHyperlink(alarm.getAlarmData().get("hyperlinkOrd").toString(), op);
    }
    else
    {
      HxUtil.makeImage(blankImg, (String) null, (String) null, "\"", op);
    }

    cameraIcon = this.getVideoImage(alarm);
    if (cameraIcon != null)
    {
      HxUtil.makeImage(cameraIcon, (String) null, (String) null, "\"", op);
    }

    HxUtil.makeImage(img, (String) null, (String) null, "\"", op);
    out.w("</td>");
    out.w("<td>");
    BasicContext timestampContext = new BasicContext(op, HX_TIMESTAMP_FACETS);
    safe(out, alarm.getTimestamp().toString(timestampContext));
    out.w("</td>");
    out.w("<td>");
    safe(out, source.toString());
    out.w("</td>");
    out.w("<td >");
    safe(out, alarm.getSourceState().toString(op));
    out.w("</td>");
    if (rec != null)
    {
      if (rec.pendingCount == 0)
      {
        out.w("<td >");
        safe(out, rec.ackedCount + " Acked / " + rec.unackedCount + " Unacked");
        out.w("</td>");
      }
      else
      {
        out.w("<td >");
        safe(out, rec.ackedCount + " Acked / " + rec.unackedCount + " Unacked / " + rec.pendingCount + " Ack Pending");
        out.w("</td>");
      }
    }
    else
    {
      out.w("<td >");
      safe(out, alarm.getAckState().toString(op));
      out.w("</td>");
    }

    out.w("<td >");
    safe(out, "" + alarm.getPriority());
    out.w("</td>");
    out.w("<td >");
    safe(out, SlotPath.unescape(this.getAlarmService().getAlarmClassDisplayName(BString.make(alarm.getAlarmClass()), op).toString()));
    out.w("</td>");
    out.w("<td >");
    safe(out, msgText);
    out.w("</td>");
    out.w("</tr>");
  }

  public static void safe(HtmlWriter out, Object object)
  {
    if (object == null)
    {
      out.w("&nbsp;");
    }
    else
    {
      String s = object.toString();
      if (s == null)
      {
        out.w("&nbsp;");
      }

      if (s != null && (s.equals("") || s.equals(" ") || s.equals("&nbsp;")))
      {
        out.w("&nbsp;");
        return;
      }

      out.safe(s);
    }

  }

  public BImage getVideoImage(BAlarmRecord alarm)
  {
    return null;
  }

  protected void makeAlarmHyperlink(String ord, HxOp op)
    throws Exception
  {
    HtmlWriter out = op.getHtmlWriter();
    out.w("<a href=\"" + ord + "\">");
    HxUtil.makeImage(linkImg, "class=\"hx-AlarmConsole-sortImg\"", (String) null, "\"", op);
    out.w("</a>");
  }

  public BAlarmService getAlarmService()
  {
    if (this.alarmService == null)
    {
      this.alarmService = (BAlarmService) Sys.getService(BAlarmService.TYPE);
    }

    return this.alarmService;
  }

  public AlarmCommand[] getCommands(boolean recurring, HxOp op)
  {
    List<AlarmCommand> arr = new ArrayList();
    arr.add(this.acknowledge);
    if (!recurring)
    {
      arr.add(this.showRecurring);
    }
    else
    {
      arr.add(this.showAll);
    }

    BPermissions permissions = op.getPermissionsForTarget();
    if (permissions.hasOperatorWrite())
    {
      arr.add(this.addNotes);
    }

    arr.add(this.showDetails);
    if (permissions.hasAdminWrite() || permissions.hasAdminInvoke())
    {
      arr.add(this.forceClear);
    }

    return (AlarmCommand[]) arr.toArray(new AlarmCommand[arr.size()]);
  }

  private void sortSourceAlarms(List<SourceAlarm> entries, String p, Comparator<? super Object> comparator)
  {
    int n = entries.size();

    for (int incr = n / 2; incr >= 1; incr /= 2)
    {
      for (int i = incr; i < n; ++i)
      {
        SourceAlarm tempValue = (SourceAlarm) entries.get(i);
        Object tempKey = tempValue.get(p);

        int j;
        for (j = i; j >= incr && comparator.compare(tempKey, ((SourceAlarm) entries.get(j - incr)).get(p)) <= 0; j -= incr)
        {
          if (comparator.compare(tempKey, ((SourceAlarm) entries.get(j - incr)).get(p)) == 0)
          {
            BAbsTime ts1 = (BAbsTime) tempValue.get(BAlarmRecord.timestamp.getName());
            BAbsTime ts2 = (BAbsTime) ((SourceAlarm) entries.get(j - incr)).get(BAlarmRecord.timestamp.getName());
            if (!ts2.isBefore(ts1))
            {
              break;
            }

            entries.set(j, entries.get(j - incr));
          }
          else
          {
            entries.set(j, entries.get(j - incr));
          }
        }

        entries.set(j, tempValue);
      }
    }

  }

  private void sortAlarms(List<BAlarmRecord> entries, String p, Comparator<? super Object> comparator)
  {
    int n = entries.size();

    for (int incr = n / 2; incr >= 1; incr /= 2)
    {
      for (int i = incr; i < n; ++i)
      {
        BAlarmRecord tempValue = (BAlarmRecord) entries.get(i);
        Object tempKey = tempValue.get(p);

        int j;
        for (j = i; j >= incr && comparator.compare(tempKey, ((BAlarmRecord) entries.get(j - incr)).get(p)) <= 0; j -= incr)
        {
          if (comparator.compare(tempKey, ((BAlarmRecord) entries.get(j - incr)).get(p)) == 0)
          {
            BAbsTime ts1 = tempValue.getTimestamp();
            BAbsTime ts2 = ((BAlarmRecord) entries.get(j - incr)).getTimestamp();
            if (!ts2.isBefore(ts1))
            {
              break;
            }

            entries.set(j, entries.get(j - incr));
          }
          else
          {
            entries.set(j, entries.get(j - incr));
          }
        }

        entries.set(j, tempValue);
      }
    }

  }

  public String[] getSelection(HxOp op)
  {
    List<String> list = new ArrayList();
    String[] keys = op.getFormKeys();

    for (int i = 0; i < keys.length; ++i)
    {
      if (keys[i].startsWith("_"))
      {
        list.add(keys[i]);
      }
    }

    String[] ids = new String[list.size()];

    for (int i = 0; i < ids.length; ++i)
    {
      String temp = ((String) list.get(i)).substring(1);
      ids[i] = temp;
    }

    return ids;
  }

  private String sessionScope(String name, HxOp op)
  {
    String ord = op.getOrd().relativizeToSession().toString();
    int index = ord.indexOf("|view:");
    if (index > -1)
    {
      ord = ord.substring(0, index);
    }

    return ord + "|" + op.getPath() + "|" + name;
  }

  static
  {
    HX_TIMESTAMP_FACETS = BFacets.make("showSeconds", BBoolean.TRUE, "showMilliseconds", BBoolean.FALSE);
    yellowAlarmImg = BImage.make("module://icons/x16/alarm.png");
    redAlarmImg = BImage.make("module://alarm/com/tridium/alarm/icons/alarmRed.png");
    greenAlarmImg = BImage.make("module://alarm/com/tridium/alarm/icons/alarmGreen.png");
    orangeAlarmImg = BImage.make("module://alarm/com/tridium/alarm/icons/alarmOrange.png");
    sortAsc = BImage.make(BIcon.std("moveUp.png"));
    sortDesc = BImage.make(BIcon.std("moveDown.png"));
    arrow = BImage.make("module://icons/x16/doubleArrowRight.png");
    linkImg = BImage.make(BIcon.std("link.png"));
    blankImg = BImage.make(BIcon.std("blank.png"));
  }

  public class SortCommand
    extends Command
  {
    public SortCommand(BHxView view)
    {
      super(view);
    }

    public String getDisplayName(HxOp op)
    {
      return "sortCommand";
    }

    public void handle(HxOp op)
      throws Exception
    {
      HtmlWriter out = op.getHtmlWriter();
      boolean showAll = true;
      Object sessionRecurring = op.getRequest().getSession().getAttribute(BProtectedHxAlarmConsoleView.this.sessionScope("recurring", op));
      Object sessionSource = op.getRequest().getSession().getAttribute(BProtectedHxAlarmConsoleView.this.sessionScope("source", op));
      if (sessionRecurring != null)
      {
        showAll = false;
      }

      Object formRecurring = op.getFormValue("recurringAlarms");
      if (formRecurring != null)
      {
        showAll = false;
      }

      if (showAll)
      {
        out.w("document.getElementById('" + op.scope("tableRecords") + "').innerHTML='");
        out.w("<table width=\"100%\" cellspacing=\"0\" class=\"ux-table\" id=\"" + op.scope("records") + "\">");
        BProtectedHxAlarmConsoleView.this.showAll(op);
        out.w("';");
        out.w("document.getElementById('" + op.scope("commands") + "').innerHTML='");
        BProtectedHxAlarmConsoleView.this.writeCommands(BProtectedHxAlarmConsoleView.this.getCommands(false, op), op);
        out.w("';");
      }
      else
      {
        out.w("document.getElementById('" + op.scope("tableRecords") + "').innerHTML='");
        out.w("<table width=\"100%\" cellspacing=\"0\" class=\"ux-table\" id=\"" + op.scope("records") + "\">");
        String source = "";
        if (sessionSource != null)
        {
          source = sessionSource.toString();
        }
        else
        {
          source = op.getUnsafeFormValue("source");
        }

        BProtectedHxAlarmConsoleView.this.showRecurringAlarms(source, op);
        out.w("';");
        out.w("document.getElementById('" + op.scope("commands") + "').innerHTML='");
        BProtectedHxAlarmConsoleView.this.writeCommands(BProtectedHxAlarmConsoleView.this.getCommands(true, op), op);
        out.w("';");
      }

    }
  }

  public class DetailsDialog
    extends Dialog
  {
    public DetailsDialog(Command handler)
    {
      super("Alarm Details", handler);
    }

    public Command[] getCommands()
    {
      return new Command[]{ new Submit() };
    }

    public void writeContent(HxOp op)
      throws Exception
    {
      HtmlWriter out = op.getHtmlWriter();
      String[] selection = BProtectedHxAlarmConsoleView.this.getSelection(op);
      String uuidStr = selection[0];
      String bqlQuery = "alarm:|bql:SELECT * FROM openAlarms WHERE uuid='" + uuidStr + "'";
      BOrd ord = BOrd.make(bqlQuery);
      BITable<BAlarmRecord> result = (BITable) ord.resolve(op.get()).get();
      Cursor<BAlarmRecord> cur = result.cursor();
      Throwable var9 = null;

      try
      {
        if (cur.next())
        {
          BAlarmRecord alarm = (BAlarmRecord) cur.get();
          Property[] props = alarm.loadSlots().getPropertiesArray();
          out.w("<div ");
          out.w(" class='hx-AlarmConsole-detailsRow' style='overflow:auto; width:100%;'");
          out.w(">");
          String detailsRowClass = "hx-AlarmConsole-detailsRow window-bg control-border hx-PropertySheet-row";
          out.w("<table width='100%' cellpadding='3' cellspacing='0' style='padding:5px'>");

          for (int i = 0; i < props.length; ++i)
          {
            if (!Flags.isHidden(alarm, props[i]))
            {
              out.w("<tr>");
              out.w("<td nowrap width='1%' class='" + detailsRowClass + "'><b>");
              BProtectedHxAlarmConsoleView.safe(out, props[i].getDefaultDisplayName(op));
              out.w("</b></td>");
              if (props[i].equals(BAlarmRecord.alarmData))
              {
                BFacets facets = alarm.getAlarmData();
                String[] keys = facets.list();
                SortUtil.sort(keys, keys, (s1, s2) -> {
                  return s1.compareToIgnoreCase(s2);
                });
                out.w("<td class='" + detailsRowClass + "'>");
                out.w("<table cellpadding='3' cellspacing='0'>");

                for (int k = 0; k < keys.length; ++k)
                {
                  String notes;
                  if (!keys[k].equals("notes") && !keys[k].equals("instructions"))
                  {
                    if (props[i].getName().equals("alarmClass"))
                    {
                      notes = alarm.get(props[i]).toString(op);
                      notes = BProtectedHxAlarmConsoleView.this.getAlarmService().getAlarmClassDisplayName(BString.make(notes), op).toString();
                      out.w("<td class='" + detailsRowClass + "'>");
                      BProtectedHxAlarmConsoleView.safe(out, notes);
                      out.w("</td>");
                    }
                    else
                    {
                      out.w("<tr>");
                      out.w("<td nowrap><b>" + keys[k] + "</b></td>");
                      out.w("<td>");
                      BProtectedHxAlarmConsoleView.safe(out, BFormat.format(SlotPath.unescape(facets.get(keys[k]).toString(op)), alarm));
                      out.w("</td>");
                      out.w("</tr>");
                    }
                  }
                  else
                  {
                    notes = SlotPath.unescape(facets.get(keys[k]).toString(op));
                    String[] split = TextUtil.split(notes, '\n');

                    for (int j = 0; j < split.length; ++j)
                    {
                      split[j] = XWriter.safeToString(split[j], true);
                    }

                    notes = TextUtil.join(split, '\n');
                    notes = TextUtil.replace(notes, "\n", "<br/>");
                    out.w("<tr>");
                    out.w("<td nowrap><b>");
                    BProtectedHxAlarmConsoleView.safe(out, keys[k]);
                    out.w("</b></td>");
                    out.w("<td>");
                    out.w(notes);
                    out.w("</td>");
                    out.w("</tr>");
                  }
                }

                out.w("</table></div>");
                out.w("</td>");
              }
              else if (props[i].getType().equals(BAbsTime.TYPE))
              {
                out.w("<td class='" + detailsRowClass + "'>");
                BProtectedHxAlarmConsoleView.safe(out, SlotPath.unescape(alarm.get(props[i]).toString(BFacets.make(op.getFacets(), BProtectedHxAlarmConsoleView.HX_TIMESTAMP_FACETS))));
                out.w("</td>");
              }
              else
              {
                out.w("<td class='" + detailsRowClass + "'>");
                BProtectedHxAlarmConsoleView.safe(out, SlotPath.unescape(alarm.get(props[i]).toString(op)));
                out.w("</td>");
              }

              out.w("</tr>");
            }
          }

          out.w("</table>");
          out.w("</div>");
        }
      }
      catch (Throwable var27)
      {
        var9 = var27;
        throw var27;
      }
      finally
      {
        if (cur != null)
        {
          if (var9 != null)
          {
            try
            {
              cur.close();
            }
            catch (Throwable var26)
            {
              var9.addSuppressed(var26);
            }
          }
          else
          {
            cur.close();
          }
        }

      }

    }
  }

  public class ShowDetails
    extends AlarmCommand
  {
    DetailsDialog dlg = BProtectedHxAlarmConsoleView.this.new DetailsDialog(this);

    public ShowDetails(BHxView view)
    {
      super(view);
    }

    public String getDisplayName(HxOp op)
    {
      return BProtectedHxAlarmConsoleView.lexicon.getText("hx.showDetails.label");
    }

    public BImage getIcon(HxOp op)
    {
      return BImage.make(BIcon.make(BProtectedHxAlarmConsoleView.lexicon.getText("hx.showDetails.icon")));
    }

    public void handle(HxOp op)
      throws Exception
    {
      String[] selection = BProtectedHxAlarmConsoleView.this.getSelection(op);
      if (selection.length >= 1)
      {
        if (!this.dlg.isSubmit(op))
        {
          this.dlg.open(op);
        }
      }
    }
  }

  public class ShowAll
    extends AlarmCommand
  {
    public ShowAll(BHxView view)
    {
      super(view);
    }

    public String getDisplayName(HxOp op)
    {
      return BProtectedHxAlarmConsoleView.lexicon.getText("hx.showAll.label");
    }

    public BImage getIcon(HxOp op)
    {
      return BImage.make(BIcon.make(BProtectedHxAlarmConsoleView.lexicon.getText("hx.showAll.icon")));
    }

    public void handle(HxOp op)
      throws Exception
    {
      op.getRequest().getSession().setAttribute(BProtectedHxAlarmConsoleView.this.sessionScope("recurring", op), (Object) null);
      op.getRequest().getSession().setAttribute(BProtectedHxAlarmConsoleView.this.sessionScope("source", op), (Object) null);
      HtmlWriter out = op.getHtmlWriter();
      out.w("document.getElementById('" + op.scope("tableTitle") + "').innerHTML='");
      BProtectedHxAlarmConsoleView.this.writeTableTitle(false, op);
      out.w("';");
      out.w("document.getElementById('" + op.scope("tableRecords") + "').innerHTML='");
      out.w("<table width=\"100%\" cellspacing=\"0\" class=\"ux-table\" id=\"" + op.scope("records") + "\">");
      BProtectedHxAlarmConsoleView.this.showAll(op);
      out.w("';");
      out.w("document.getElementById('" + op.scope("commands") + "').innerHTML='");
      BProtectedHxAlarmConsoleView.this.writeCommands(BProtectedHxAlarmConsoleView.this.getCommands(false, op), op);
      out.w("';");
    }
  }

  public class ShowRecurring
    extends AlarmCommand
  {
    public ShowRecurring(BHxView view)
    {
      super(view);
    }

    public String getDisplayName(HxOp op)
    {
      return BProtectedHxAlarmConsoleView.lexicon.getText("hx.showRecurring.label");
    }

    public BImage getIcon(HxOp op)
    {
      return BImage.make(BIcon.make(BProtectedHxAlarmConsoleView.lexicon.getText("hx.showRecurring.icon")));
    }

    public void handle(HxOp op)
      throws Exception
    {
      if (BProtectedHxAlarmConsoleView.this.getSelection(op).length != 0)
      {
        op.getRequest().getSession().setAttribute(BProtectedHxAlarmConsoleView.this.sessionScope("recurring", op), "true");
        op.getRequest().getSession().setAttribute(BProtectedHxAlarmConsoleView.this.sessionScope("source", op), op.getFormValue("_" + BProtectedHxAlarmConsoleView.this.getSelection(op)[0]));
        HtmlWriter out = op.getHtmlWriter();
        out.w("document.getElementById('" + op.scope("tableTitle") + "').innerHTML='");
        BProtectedHxAlarmConsoleView.this.writeTableTitle(true, op);
        out.w("';");
        out.w("document.getElementById('" + op.scope("tableRecords") + "').innerHTML='");
        out.w("<table width=\"100%\" cellspacing=\"0\" class=\"ux-table\" id=\"" + op.scope("records") + "\">");
        BProtectedHxAlarmConsoleView.this.showRecurringAlarms(op.getFormValue("_" + BProtectedHxAlarmConsoleView.this.getSelection(op)[0]), op);
        out.w("';");
        out.w("document.getElementById('" + op.scope("commands") + "').innerHTML='");
        BProtectedHxAlarmConsoleView.this.writeCommands(BProtectedHxAlarmConsoleView.this.getCommands(true, op), op);
        out.w("';");
      }
    }
  }

  public class ForceClear
    extends AlarmCommand
  {
    public ForceClear(BHxView view)
    {
      super(view);
    }

    public String getDisplayName(HxOp op)
    {
      return BProtectedHxAlarmConsoleView.lexicon.getText("hx.forceClear.label");
    }

    public BImage getIcon(HxOp op)
    {
      return BImage.make(BIcon.make(BProtectedHxAlarmConsoleView.lexicon.getText("hx.forceClear.icon")));
    }

    public void handle(HxOp op)
      throws Exception
    {
      if (op.getPermissionsForTarget().hasAdminInvoke() || op.getPermissionsForTarget().hasAdminWrite())
      {
        String[] uuids;
        String alarmNotes = op.getFormValue("hiddenNotes");

        int i;
        if (op.getUnsafePostBody() != null && op.getFormValue("recurringAlarms") != null)
        {
          uuids = BProtectedHxAlarmConsoleView.this.getSelection(op);

          for (i = 0; i < uuids.length; ++i)
          {
            BProtectedHxAlarmConsoleView.this.forceClearByUuid(uuids[i], alarmNotes, op);
          }
        }
        else
        {
          uuids = BProtectedHxAlarmConsoleView.this.getSelection(op);

          for (i = 0; i < uuids.length; ++i)
          {
            BProtectedHxAlarmConsoleView.this.forceClearBySource(op.getFormValue("_" + uuids[i]), alarmNotes, op);
          }
        }

        HtmlWriter out = op.getHtmlWriter();
        out.w("document.getElementById('" + op.scope("tableRecords") + "').innerHTML='");
        out.w("<table width=\"100%\" cellspacing=\"0\" class=\"ux-table\" id=\"" + op.scope("records") + "\">");
        if (op.getFormValue("recurringAlarms") == null)
        {
          BProtectedHxAlarmConsoleView.this.showAll(op);
        }
        else
        {
          BProtectedHxAlarmConsoleView.this.showRecurringAlarms(op.getUnsafeFormValue("source"), op);
        }

        out.w("';");
      }

    }
  }

  public class AlarmNotesDialog
    extends Dialog
  {
    public AlarmNotesDialog(Command handler)
    {
      super("Alarm Notes", handler);
    }

    public Command[] getCommands()
    {
      return new Command[]{ new Submit(), new Cancel() };
    }

    public void writeContent(HxOp op)
      throws Exception
    {
      String alarmNotes = this.getAlarmNotes(op);
      HtmlWriter out = op.getHtmlWriter();
      out.w("<div style='display:block;' >");
      out.w("<textarea rows='4' cols='40' readonly='yes' wrap='hard'>");
      out.safe(alarmNotes);
      out.w("</textarea><br />");
      out.w("</div>");
      out.w("<textarea rows='4' cols='40' name='" + op.scope("notes") + "' >");
      out.w("</textarea>");
    }

    private String getAlarmNotes(HxOp op)
    {
      String[] uuids = BProtectedHxAlarmConsoleView.this.getSelection(op);
      String notes = "";
      int i;
      if (op.getUnsafePostBody() != null && op.getFormValue("recurringAlarms") != null)
      {
        for (i = 0; i < uuids.length; ++i)
        {
          notes = notes + this.getAlarmNotesByUUID(op, uuids[i]);
        }
      }
      else
      {
        for (i = 0; i < uuids.length; ++i)
        {
          String source = op.getFormValue("_" + uuids[i]);
          notes = notes + this.getAlarmNotesBySource(op, source);
        }
      }

      return notes;
    }

    private String getAlarmNotesBySource(HxOp op, String src)
    {
      if (src == null)
      {
        return "";
      }
      else
      {
        BOrd ord = BOrd.make("alarm:|bql:select * from openAlarms where source = OrdList '" + src + "'");
        BITable<BAlarmRecord> result = (BITable) ord.resolve(op.get()).get();
        List<BAlarmRecord> arr = new ArrayList();
        Cursor<BAlarmRecord> cur = result.cursor();
        Throwable var7 = null;

        try
        {
          while (cur.next())
          {
            arr.add((BAlarmRecord) ((BAlarmRecord) cur.get()).newCopy());
          }
        }
        catch (Throwable var16)
        {
          var7 = var16;
          throw var16;
        }
        finally
        {
          if (cur != null)
          {
            if (var7 != null)
            {
              try
              {
                cur.close();
              }
              catch (Throwable var15)
              {
                var7.addSuppressed(var15);
              }
            }
            else
            {
              cur.close();
            }
          }

        }

        StringBuffer buffer = new StringBuffer();
        if (arr.size() > 1)
        {
          buffer.append(BProtectedHxAlarmConsoleView.lexicon.getText("hx.notes.multiple") + "\n");
        }

        for (int j = 0; j < arr.size(); ++j)
        {
          BAlarmRecord alarm = (BAlarmRecord) arr.get(j);
          BObject value = alarm.getAlarmData().get("notes");
          if (null != value)
          {
            buffer.append(value.toString());
          }
        }

        return buffer.toString();
      }
    }

    private String getAlarmNotesByUUID(HxOp op, String uuid)
    {
      if (uuid == null)
      {
        return "";
      }
      else
      {
        StringBuffer buffer = new StringBuffer();
        BOrd ord = BOrd.make("alarm:|bql:select * from openAlarms where uuid = Uuid '" + uuid + "'");
        BITable<BAlarmRecord> result = (BITable) ord.resolve(op.get()).get();
        List<BAlarmRecord> arr = new ArrayList();
        Cursor<BAlarmRecord> cur = result.cursor();
        Throwable var8 = null;

        try
        {
          while (cur.next())
          {
            arr.add((BAlarmRecord) ((BAlarmRecord) cur.get()).newCopy());
          }
        }
        catch (Throwable var17)
        {
          var8 = var17;
          throw var17;
        }
        finally
        {
          if (cur != null)
          {
            if (var8 != null)
            {
              try
              {
                cur.close();
              }
              catch (Throwable var16)
              {
                var8.addSuppressed(var16);
              }
            }
            else
            {
              cur.close();
            }
          }

        }

        if (arr.size() > 1)
        {
          buffer.append(BProtectedHxAlarmConsoleView.lexicon.getText("hx.notes.multiple") + "\n");
        }

        for (int j = 0; j < arr.size(); ++j)
        {
          BAlarmRecord alarm = (BAlarmRecord) arr.get(j);
          BObject value = alarm.getAlarmData().get("notes");
          if (null != value)
          {
            buffer.append(value.toString());
          }
        }

        return buffer.toString();
      }
    }
  }

  public class AddNotes
    extends AlarmCommand
  {
    Dialog dlg = BProtectedHxAlarmConsoleView.this.new AlarmNotesDialog(this);

    public AddNotes(BHxView view)
    {
      super(view);
    }

    public String getDisplayName(HxOp op)
    {
      return BProtectedHxAlarmConsoleView.lexicon.getText("hx.addNotes.label");
    }

    public BImage getIcon(HxOp op)
    {
      return BImage.make(BIcon.make(BProtectedHxAlarmConsoleView.lexicon.getText("hx.notes.icon")));
    }

    public void handle(HxOp op)
      throws Exception
    {
      if (!this.dlg.isSubmit(op))
      {
        this.dlg.open(op);
      }
      else
      {
        String notes = op.getFormValue("notes");
        String[] uuids = BProtectedHxAlarmConsoleView.this.getSelection(op);
        int i;
        if (op.getUnsafePostBody() != null && op.getFormValue("recurringAlarms") != null)
        {
          for (i = 0; i < uuids.length; ++i)
          {
            BProtectedHxAlarmConsoleView.this.addAlarmNoteByUuid(uuids[i], notes, op);
          }
        }
        else
        {
          for (i = 0; i < uuids.length; ++i)
          {
            String source = op.getFormValue("_" + uuids[i]);
            BProtectedHxAlarmConsoleView.this.addAlarmNoteBySource(source, notes, op);
          }
        }

        HtmlWriter out = op.getHtmlWriter();
        out.w("document.getElementById('" + op.scope("tableRecords") + "').innerHTML='");
        out.w("<table width=\"100%\" cellspacing=\"0\" class=\"ux-table\" id=\"" + op.scope("records") + "\">");
        if (op.getFormValue("recurringAlarms") == null)
        {
          BProtectedHxAlarmConsoleView.this.showAll(op);
        }
        else
        {
          BProtectedHxAlarmConsoleView.this.showRecurringAlarms(op.getUnsafeFormValue("source"), op);
        }

        out.w("';");
      }
    }
  }

  public class Acknowledge
    extends AlarmCommand
  {
    public Acknowledge(BHxView view)
    {
      super(view);
    }

    public String getDisplayName(HxOp op)
    {
      return BProtectedHxAlarmConsoleView.lexicon.getText("hx.acknowledge.label");
    }

    public BImage getIcon(HxOp op)
    {
      return BImage.make(BIcon.make(BProtectedHxAlarmConsoleView.lexicon.getText("hx.acknowledge.icon")));
    }

    public void handle(HxOp op)
      throws Exception
    {

      String alarmNotes = op.getFormValue("hiddenNotes");
      String[] uuids;
      int i;
      if (op.getUnsafePostBody() != null && op.getFormValue("recurringAlarms") != null)
      {
        uuids = BProtectedHxAlarmConsoleView.this.getSelection(op);

        for (i = 0; i < uuids.length; ++i)
        {
          BProtectedHxAlarmConsoleView.this.ackAlarmByUuid(uuids[i], (String) alarmNotes, op);
        }
      }
      else
      {
        uuids = BProtectedHxAlarmConsoleView.this.getSelection(op);

        for (i = 0; i < uuids.length; ++i)
        {
          BProtectedHxAlarmConsoleView.this.ackAlarmBySource(op.getFormValue("_" + uuids[i]), (String) alarmNotes, op);
        }
      }

      HtmlWriter out = op.getHtmlWriter();
      out.w("document.getElementById('" + op.scope("tableRecords") + "').innerHTML='");
      out.w("<table width=\"100%\" cellspacing=\"0\" class=\"ux-table\" id=\"" + op.scope("records") + "\">");
      if (op.getFormValue("recurringAlarms") == null)
      {
        BProtectedHxAlarmConsoleView.this.showAll(op);
      }
      else
      {
        BProtectedHxAlarmConsoleView.this.showRecurringAlarms(op.getUnsafeFormValue("source"), op);
      }

      out.w("';");
    }
  }

  public class AlarmCommand
    extends Command
  {
    public AlarmCommand(BHxView view)
    {
      super(view);
    }

    @Override
    public String getInvokeCode(HxOp op)
    {
      String method = op.getRequest().getMethod().toLowerCase();
      String quote = method.equals("get") ? "\"" : "&quot;";
      StringBuffer buf = new StringBuffer();
      buf.append("hx.fireEvent(");
      buf.append(quote).append(op.getPath()).append(quote);
      buf.append(",");
      buf.append(quote).append(this.getId()).append(quote);
      buf.append(");");
      return buf.toString();
    }

    public BImage getIcon(HxOp op)
    {
      return null;
    }
  }

  protected class LoadThread
    extends Thread
  {
    public HxOp op;

    public LoadThread(HxOp op)
    {
      this.op = op;
    }

    public void run()
    {
      try
      {
        HtmlWriter out = this.op.getHtmlWriter();
        out.w("document.getElementById('" + this.op.scope("tableRecords") + "').innerHTML='");
        out.w("<table width=\"100%\" cellspacing=\"0\" class=\"ux-table\" id=\"" + this.op.scope("records") + "\">");
        BProtectedHxAlarmConsoleView.this.showAll(this.op);
        out.w("\";");
      }
      catch (Exception var2)
      {
        var2.printStackTrace();
      }

    }
  }

  protected class SourceAlarm
  {
    public BAlarmRecord alarm;
    public int ackedCount;
    public int unackedCount;
    public int pendingCount;

    public SourceAlarm()
    {
      this.alarm = new BAlarmRecord(BUuid.DEFAULT);
      this.ackedCount = 0;
      this.unackedCount = 0;
      this.pendingCount = 0;
      this.alarm.setTimestamp(BAbsTime.NULL);
    }

    public Object get(String s)
    {
      return s.equals(BAlarmRecord.ackState.getName()) ? this.ackedCount + "/" + this.unackedCount + "/" + this.pendingCount : this.alarm.get(s);
    }

    public void update(BAlarmRecord rec)
    {
      if (this.alarm.getTimestamp().isBefore(rec.getTimestamp()))
      {
        this.alarm = rec;
      }

      if (rec.isAcknowledged())
      {
        ++this.ackedCount;
      }
      else if (rec.isAckPending())
      {
        ++this.pendingCount;
      }
      else
      {
        ++this.unackedCount;
      }

    }
  }
}
